import { AST, Expr, Method, OptionsStanza, OptionsAST, ParserSymbol } from './AST';
import { Encoding } from './Encoding';
export declare const expr0: ParserSymbol;
export declare const expr1: Method;
export declare const expr2: Method;
export declare const valueExprs1: Expr[];
export declare const chessDSL = "WOPR|print('how','about','a','nice','game')|println('OF','CHESS')";
export declare const defconDSL = "WOPR|defenseCondition(0)|prefix('xxx')|rangeValue(ranges)|matchValue(matches)";
export declare const ast: AST;
export declare const dslEncoding: Encoding;
export declare const dynamicOptions: OptionsStanza;
export declare const optionsAST: OptionsAST;
export declare const context: {
    majorThreshold: ({
        from: number;
        value: string;
        to?: undefined;
    } | {
        from: number;
        to: number;
        value: string;
    } | {
        to: number;
        value: string;
        from?: undefined;
    })[];
    deltaThreshold: ({
        from: number;
        value: string;
        to?: undefined;
    } | {
        from: number;
        to: number;
        value: string;
    } | {
        to: number;
        value: string;
        from?: undefined;
    })[];
    backgroundThreshold: ({
        from: number;
        value: string;
        to?: undefined;
    } | {
        from: number;
        to: number;
        value: string;
    } | {
        to: number;
        value: string;
        from?: undefined;
    })[];
};
export declare const svDynamicOptions: OptionsStanza;
export declare const svDynamicOptions2: OptionsStanza;
export declare const testThemeRegistry: any;
