/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __esm = (fn, res) => function __init() {
  return fn && (res = (0, fn[__getOwnPropNames(fn)[0]])(fn = 0)), res;
};
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// <define:global>
var init_define_global = __esm({
  "<define:global>"() {
  }
});

// src/nearley/generated/vizparser.js
var require_vizparser = __commonJS({
  "src/nearley/generated/vizparser.js"(exports, module2) {
    init_define_global();
    (function() {
      function arrpush(d) {
        return d[0].concat([d[1]]);
      }
      function id(x) {
        return x[0];
      }
      function parseNull() {
        return null;
      }
      function parseString(d) {
        return { type: "string", v: d[0] };
      }
      function parseJoin(d) {
        return d[1].join("");
      }
      var grammar2 = {
        Lexer: void 0,
        ParserRules: [
          { name: "_$ebnf$1", symbols: [] },
          {
            name: "_$ebnf$1",
            symbols: ["_$ebnf$1", "wschar"],
            postprocess: arrpush
          },
          {
            name: "_",
            symbols: ["_$ebnf$1"],
            postprocess: parseNull
          },
          { name: "__$ebnf$1", symbols: ["wschar"] },
          {
            name: "__$ebnf$1",
            symbols: ["__$ebnf$1", "wschar"],
            postprocess: arrpush
          },
          {
            name: "__",
            symbols: ["__$ebnf$1"],
            postprocess: parseNull
          },
          { name: "wschar", symbols: [/[ \t\n\v\f]/], postprocess: id },
          { name: "dqstring$ebnf$1", symbols: [] },
          {
            name: "dqstring$ebnf$1",
            symbols: ["dqstring$ebnf$1", "dstrchar"],
            postprocess: arrpush
          },
          {
            name: "dqstring",
            symbols: [{ literal: '"' }, "dqstring$ebnf$1", { literal: '"' }],
            postprocess: parseJoin
          },
          { name: "sqstring$ebnf$1", symbols: [] },
          {
            name: "sqstring$ebnf$1",
            symbols: ["sqstring$ebnf$1", "sstrchar"],
            postprocess: arrpush
          },
          {
            name: "sqstring",
            symbols: [{ literal: "'" }, "sqstring$ebnf$1", { literal: "'" }],
            postprocess: parseJoin
          },
          { name: "btstring$ebnf$1", symbols: [] },
          {
            name: "btstring$ebnf$1",
            symbols: ["btstring$ebnf$1", /[^`]/],
            postprocess: arrpush
          },
          {
            name: "btstring",
            symbols: [{ literal: "`" }, "btstring$ebnf$1", { literal: "`" }],
            postprocess: parseJoin
          },
          { name: "dstrchar", symbols: [/[^\\"\n]/], postprocess: id },
          {
            name: "dstrchar",
            symbols: [{ literal: "\\" }, "strescape"],
            postprocess: function(d) {
              return JSON.parse('"' + d.join("") + '"');
            }
          },
          { name: "sstrchar", symbols: [/[^\\'\n]/], postprocess: id },
          {
            name: "sstrchar",
            symbols: [{ literal: "\\" }, "strescape"],
            postprocess: function(d) {
              return JSON.parse('"' + d.join("") + '"');
            }
          },
          {
            name: "sstrchar$string$1",
            symbols: [{ literal: "\\" }, { literal: "'" }],
            postprocess: function joiner(d) {
              return d.join("");
            }
          },
          {
            name: "sstrchar",
            symbols: ["sstrchar$string$1"],
            postprocess: function(d) {
              return "'";
            }
          },
          { name: "strescape", symbols: [/["\\/bfnrt]/], postprocess: id },
          {
            name: "strescape",
            symbols: [{ literal: "u" }, /[a-fA-F0-9]/, /[a-fA-F0-9]/, /[a-fA-F0-9]/, /[a-fA-F0-9]/],
            postprocess: function(d) {
              return d.join("");
            }
          },
          { name: "unsigned_int$ebnf$1", symbols: [/[0-9]/] },
          {
            name: "unsigned_int$ebnf$1",
            symbols: ["unsigned_int$ebnf$1", /[0-9]/],
            postprocess: arrpush
          },
          {
            name: "unsigned_int",
            symbols: ["unsigned_int$ebnf$1"],
            postprocess: function(d) {
              return parseInt(d[0].join(""));
            }
          },
          { name: "int$ebnf$1$subexpression$1", symbols: [{ literal: "-" }] },
          { name: "int$ebnf$1$subexpression$1", symbols: [{ literal: "+" }] },
          { name: "int$ebnf$1", symbols: ["int$ebnf$1$subexpression$1"], postprocess: id },
          {
            name: "int$ebnf$1",
            symbols: [],
            postprocess: parseNull
          },
          { name: "int$ebnf$2", symbols: [/[0-9]/] },
          {
            name: "int$ebnf$2",
            symbols: ["int$ebnf$2", /[0-9]/],
            postprocess: arrpush
          },
          {
            name: "int",
            symbols: ["int$ebnf$1", "int$ebnf$2"],
            postprocess: function(d) {
              if (d[0]) {
                return parseInt(d[0][0] + d[1].join(""));
              } else {
                return parseInt(d[1].join(""));
              }
            }
          },
          { name: "unsigned_decimal$ebnf$1", symbols: [/[0-9]/] },
          {
            name: "unsigned_decimal$ebnf$1",
            symbols: ["unsigned_decimal$ebnf$1", /[0-9]/],
            postprocess: arrpush
          },
          { name: "unsigned_decimal$ebnf$2$subexpression$1$ebnf$1", symbols: [/[0-9]/] },
          {
            name: "unsigned_decimal$ebnf$2$subexpression$1$ebnf$1",
            symbols: ["unsigned_decimal$ebnf$2$subexpression$1$ebnf$1", /[0-9]/],
            postprocess: arrpush
          },
          {
            name: "unsigned_decimal$ebnf$2$subexpression$1",
            symbols: [{ literal: "." }, "unsigned_decimal$ebnf$2$subexpression$1$ebnf$1"]
          },
          {
            name: "unsigned_decimal$ebnf$2",
            symbols: ["unsigned_decimal$ebnf$2$subexpression$1"],
            postprocess: id
          },
          {
            name: "unsigned_decimal$ebnf$2",
            symbols: [],
            postprocess: parseNull
          },
          {
            name: "unsigned_decimal",
            symbols: ["unsigned_decimal$ebnf$1", "unsigned_decimal$ebnf$2"],
            postprocess: function(d) {
              return parseFloat(d[0].join("") + (d[1] ? "." + d[1][1].join("") : ""));
            }
          },
          { name: "decimal$ebnf$1", symbols: [{ literal: "-" }], postprocess: id },
          {
            name: "decimal$ebnf$1",
            symbols: [],
            postprocess: parseNull
          },
          { name: "decimal$ebnf$2", symbols: [/[0-9]/] },
          {
            name: "decimal$ebnf$2",
            symbols: ["decimal$ebnf$2", /[0-9]/],
            postprocess: arrpush
          },
          { name: "decimal$ebnf$3$subexpression$1$ebnf$1", symbols: [/[0-9]/] },
          {
            name: "decimal$ebnf$3$subexpression$1$ebnf$1",
            symbols: ["decimal$ebnf$3$subexpression$1$ebnf$1", /[0-9]/],
            postprocess: arrpush
          },
          {
            name: "decimal$ebnf$3$subexpression$1",
            symbols: [{ literal: "." }, "decimal$ebnf$3$subexpression$1$ebnf$1"]
          },
          { name: "decimal$ebnf$3", symbols: ["decimal$ebnf$3$subexpression$1"], postprocess: id },
          {
            name: "decimal$ebnf$3",
            symbols: [],
            postprocess: parseNull
          },
          {
            name: "decimal",
            symbols: ["decimal$ebnf$1", "decimal$ebnf$2", "decimal$ebnf$3"],
            postprocess: function(d) {
              return parseFloat((d[0] || "") + d[1].join("") + (d[2] ? "." + d[2][1].join("") : ""));
            }
          },
          {
            name: "percentage",
            symbols: ["decimal", { literal: "%" }],
            postprocess: function(d) {
              return d[0] / 100;
            }
          },
          { name: "jsonfloat$ebnf$1", symbols: [{ literal: "-" }], postprocess: id },
          {
            name: "jsonfloat$ebnf$1",
            symbols: [],
            postprocess: parseNull
          },
          { name: "jsonfloat$ebnf$2", symbols: [/[0-9]/] },
          {
            name: "jsonfloat$ebnf$2",
            symbols: ["jsonfloat$ebnf$2", /[0-9]/],
            postprocess: arrpush
          },
          { name: "jsonfloat$ebnf$3$subexpression$1$ebnf$1", symbols: [/[0-9]/] },
          {
            name: "jsonfloat$ebnf$3$subexpression$1$ebnf$1",
            symbols: ["jsonfloat$ebnf$3$subexpression$1$ebnf$1", /[0-9]/],
            postprocess: arrpush
          },
          {
            name: "jsonfloat$ebnf$3$subexpression$1",
            symbols: [{ literal: "." }, "jsonfloat$ebnf$3$subexpression$1$ebnf$1"]
          },
          { name: "jsonfloat$ebnf$3", symbols: ["jsonfloat$ebnf$3$subexpression$1"], postprocess: id },
          {
            name: "jsonfloat$ebnf$3",
            symbols: [],
            postprocess: parseNull
          },
          { name: "jsonfloat$ebnf$4$subexpression$1$ebnf$1", symbols: [/[+-]/], postprocess: id },
          {
            name: "jsonfloat$ebnf$4$subexpression$1$ebnf$1",
            symbols: [],
            postprocess: parseNull
          },
          { name: "jsonfloat$ebnf$4$subexpression$1$ebnf$2", symbols: [/[0-9]/] },
          {
            name: "jsonfloat$ebnf$4$subexpression$1$ebnf$2",
            symbols: ["jsonfloat$ebnf$4$subexpression$1$ebnf$2", /[0-9]/],
            postprocess: arrpush
          },
          {
            name: "jsonfloat$ebnf$4$subexpression$1",
            symbols: [
              /[eE]/,
              "jsonfloat$ebnf$4$subexpression$1$ebnf$1",
              "jsonfloat$ebnf$4$subexpression$1$ebnf$2"
            ]
          },
          { name: "jsonfloat$ebnf$4", symbols: ["jsonfloat$ebnf$4$subexpression$1"], postprocess: id },
          {
            name: "jsonfloat$ebnf$4",
            symbols: [],
            postprocess: parseNull
          },
          {
            name: "jsonfloat",
            symbols: ["jsonfloat$ebnf$1", "jsonfloat$ebnf$2", "jsonfloat$ebnf$3", "jsonfloat$ebnf$4"],
            postprocess: function(d) {
              return parseFloat(
                (d[0] || "") + d[1].join("") + (d[2] ? "." + d[2][1].join("") : "") + (d[3] ? "e" + (d[3][1] || "+") + d[3][2].join("") : "")
              );
            }
          },
          { name: "Pipeline$ebnf$1", symbols: [] },
          { name: "Pipeline$ebnf$1$subexpression$1", symbols: [{ literal: "|" }, "Expr"] },
          {
            name: "Pipeline$ebnf$1",
            symbols: ["Pipeline$ebnf$1", "Pipeline$ebnf$1$subexpression$1"],
            postprocess: arrpush
          },
          {
            name: "Pipeline",
            symbols: ["Expr", "Pipeline$ebnf$1"],
            postprocess: (d) => {
              return [d[0], ...d[1].map((e) => e[1])];
            }
          },
          { name: "Expr", symbols: ["_", "Identifier", "_"], postprocess: (d) => d[1] },
          { name: "Expr", symbols: ["_", "Method", "_"], postprocess: (d) => d[1] },
          { name: "Expr", symbols: ["_", "Literal", "_"], postprocess: (d) => d[1] },
          { name: "Method$ebnf$1", symbols: ["Arg"], postprocess: id },
          {
            name: "Method$ebnf$1",
            symbols: [],
            postprocess: parseNull
          },
          { name: "Method$ebnf$2", symbols: [] },
          { name: "Method$ebnf$2$subexpression$1", symbols: ["_", { literal: "," }, "_", "Arg"] },
          {
            name: "Method$ebnf$2",
            symbols: ["Method$ebnf$2", "Method$ebnf$2$subexpression$1"],
            postprocess: arrpush
          },
          {
            name: "Method",
            symbols: [
              "Identifier",
              { literal: "(" },
              "_",
              "Method$ebnf$1",
              "Method$ebnf$2",
              "_",
              { literal: ")" }
            ],
            postprocess: (d) => {
              let arg0 = d[3];
              let otherArgs = d[4];
              let args = [];
              arg0 && args.push(arg0);
              if (otherArgs) {
                args = args.concat(otherArgs.map((e) => e[3]));
              }
              let r = { type: "method", name: d[0].v, args };
              return r;
            }
          },
          { name: "Arg", symbols: ["Identifier"], postprocess: (d) => d[0] },
          { name: "Arg", symbols: ["Literal"], postprocess: (d) => d[0] },
          { name: "Identifier$subexpression$1", symbols: ["Letter"] },
          { name: "Identifier$subexpression$1", symbols: ["Star"] },
          { name: "Identifier$ebnf$1", symbols: [] },
          { name: "Identifier$ebnf$1$subexpression$1", symbols: ["Letter"] },
          { name: "Identifier$ebnf$1$subexpression$1", symbols: ["Digit"] },
          { name: "Identifier$ebnf$1$subexpression$1", symbols: ["Star"] },
          {
            name: "Identifier$ebnf$1",
            symbols: ["Identifier$ebnf$1", "Identifier$ebnf$1$subexpression$1"],
            postprocess: arrpush
          },
          {
            name: "Identifier",
            symbols: ["Identifier$subexpression$1", "Identifier$ebnf$1"],
            postprocess: (d) => {
              return { type: "identifier", v: d[0] + d[1].join("") };
            }
          },
          { name: "Identifier$subexpression$2", symbols: ["Letter"] },
          { name: "Identifier$subexpression$2", symbols: ["Star"] },
          { name: "Identifier$ebnf$2", symbols: [] },
          { name: "Identifier$ebnf$2$subexpression$1", symbols: ["Letter"] },
          { name: "Identifier$ebnf$2$subexpression$1", symbols: ["Digit"] },
          { name: "Identifier$ebnf$2$subexpression$1", symbols: ["Star"] },
          {
            name: "Identifier$ebnf$2",
            symbols: ["Identifier$ebnf$2", "Identifier$ebnf$2$subexpression$1"],
            postprocess: arrpush
          },
          { name: "Identifier$ebnf$3$subexpression$1$subexpression$1", symbols: ["Letter"] },
          { name: "Identifier$ebnf$3$subexpression$1$subexpression$1", symbols: ["Star"] },
          { name: "Identifier$ebnf$3$subexpression$1$ebnf$1", symbols: [] },
          { name: "Identifier$ebnf$3$subexpression$1$ebnf$1$subexpression$1", symbols: ["Letter"] },
          { name: "Identifier$ebnf$3$subexpression$1$ebnf$1$subexpression$1", symbols: ["Digit"] },
          { name: "Identifier$ebnf$3$subexpression$1$ebnf$1$subexpression$1", symbols: ["Star"] },
          {
            name: "Identifier$ebnf$3$subexpression$1$ebnf$1",
            symbols: [
              "Identifier$ebnf$3$subexpression$1$ebnf$1",
              "Identifier$ebnf$3$subexpression$1$ebnf$1$subexpression$1"
            ],
            postprocess: arrpush
          },
          {
            name: "Identifier$ebnf$3$subexpression$1",
            symbols: [
              "Dot",
              "Identifier$ebnf$3$subexpression$1$subexpression$1",
              "Identifier$ebnf$3$subexpression$1$ebnf$1"
            ]
          },
          { name: "Identifier$ebnf$3", symbols: ["Identifier$ebnf$3$subexpression$1"] },
          { name: "Identifier$ebnf$3$subexpression$2$subexpression$1", symbols: ["Letter"] },
          { name: "Identifier$ebnf$3$subexpression$2$subexpression$1", symbols: ["Star"] },
          { name: "Identifier$ebnf$3$subexpression$2$ebnf$1", symbols: [] },
          { name: "Identifier$ebnf$3$subexpression$2$ebnf$1$subexpression$1", symbols: ["Letter"] },
          { name: "Identifier$ebnf$3$subexpression$2$ebnf$1$subexpression$1", symbols: ["Digit"] },
          { name: "Identifier$ebnf$3$subexpression$2$ebnf$1$subexpression$1", symbols: ["Star"] },
          {
            name: "Identifier$ebnf$3$subexpression$2$ebnf$1",
            symbols: [
              "Identifier$ebnf$3$subexpression$2$ebnf$1",
              "Identifier$ebnf$3$subexpression$2$ebnf$1$subexpression$1"
            ],
            postprocess: arrpush
          },
          {
            name: "Identifier$ebnf$3$subexpression$2",
            symbols: [
              "Dot",
              "Identifier$ebnf$3$subexpression$2$subexpression$1",
              "Identifier$ebnf$3$subexpression$2$ebnf$1"
            ]
          },
          {
            name: "Identifier$ebnf$3",
            symbols: ["Identifier$ebnf$3", "Identifier$ebnf$3$subexpression$2"],
            postprocess: arrpush
          },
          {
            name: "Identifier",
            symbols: ["Identifier$subexpression$2", "Identifier$ebnf$2", "Identifier$ebnf$3"],
            postprocess: (d) => {
              function flat(input, depth = 1, stack = []) {
                for (let item of input) {
                  if (item instanceof Array && depth > 0) {
                    flat(item, depth - 1, stack);
                  } else {
                    stack.push(item);
                  }
                }
                return stack;
              }
              const r = flat(d, Infinity);
              return { type: "identifier", v: r.join("") };
            }
          },
          {
            name: "Literal",
            symbols: ["jsonfloat"],
            postprocess: (d) => {
              return { type: "number", v: d[0] };
            }
          },
          {
            name: "Literal",
            symbols: ["dqstring"],
            postprocess: parseString
          },
          {
            name: "Literal",
            symbols: ["sqstring"],
            postprocess: parseString
          },
          {
            name: "Literal",
            symbols: ["btstring"],
            postprocess: parseString
          },
          { name: "Letter", symbols: [/[a-zA-Z_]/], postprocess: (d) => d[0] },
          { name: "Digit", symbols: [/[0-9]/], postprocess: (d) => d[0] },
          { name: "Dot", symbols: [/[\.]/], postprocess: (d) => d[0] },
          { name: "Star", symbols: [{ literal: "*" }] }
        ],
        ParserStart: "Pipeline"
      };
      if (typeof module2 !== "undefined" && typeof module2.exports !== "undefined") {
        module2.exports = grammar2;
      } else {
        window.grammar = grammar2;
      }
    })();
  }
});

// src/formatters/Objects.ts
var Objects_exports = {};
__export(Objects_exports, {
  Objects: () => Objects
});
module.exports = __toCommonJS(Objects_exports);
init_define_global();

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
init_define_global();
var defaultImport = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// src/DataPoint.ts
init_define_global();

// src/TypeSafeValue.ts
init_define_global();

// src/utils/types.ts
init_define_global();

// esm-externals:@splunk/moment
var moment_exports = {};
__export(moment_exports, {
  default: () => moment_default
});
init_define_global();
var defaultImport2 = __toESM(require("@splunk/moment"));
__reExport(moment_exports, require("@splunk/moment"));
var moment_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// src/utils/colorUtils.ts
init_define_global();

// esm-externals:@splunk/visualization-schemas
var visualization_schemas_exports = {};
__export(visualization_schemas_exports, {
  default: () => visualization_schemas_default
});
init_define_global();
var defaultImport3 = __toESM(require("@splunk/visualization-schemas"));
__reExport(visualization_schemas_exports, require("@splunk/visualization-schemas"));
var visualization_schemas_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// src/utils/namedColors.ts
init_define_global();
var namedColors_default = [
  "transparent",
  "aliceblue",
  "antiquewhite",
  "aqua",
  "aquamarine",
  "azure",
  "beige",
  "bisque",
  "black",
  "blanchedalmond",
  "blue",
  "blueviolet",
  "brown",
  "burlywood",
  "cadetblue",
  "chartreuse",
  "chocolate",
  "coral",
  "cornflowerblue",
  "cornsilk",
  "crimson",
  "cyan",
  "darkblue",
  "darkcyan",
  "darkgoldenrod",
  "darkgray",
  "darkgreen",
  "darkgrey",
  "darkkhaki",
  "darkmagenta",
  "darkolivegreen",
  "darkorange",
  "darkorchid",
  "darkred",
  "darksalmon",
  "darkseagreen",
  "darkslateblue",
  "darkslategray",
  "darkslategrey",
  "darkturquoise",
  "darkviolet",
  "deeppink",
  "deepskyblue",
  "dimgray",
  "dimgrey",
  "dodgerblue",
  "firebrick",
  "floralwhite",
  "forestgreen",
  "fuchsia",
  "gainsboro",
  "ghostwhite",
  "gold",
  "goldenrod",
  "gray",
  "green",
  "greenyellow",
  "grey",
  "honeydew",
  "hotpink",
  "indianred",
  "indigo",
  "ivory",
  "khaki",
  "lavender",
  "lavenderblush",
  "lawngreen",
  "lemonchiffon",
  "lightblue",
  "lightcoral",
  "lightcyan",
  "lightgoldenrodyellow",
  "lightgray",
  "lightgreen",
  "lightgrey",
  "lightpink",
  "lightsalmon",
  "lightseagreen",
  "lightskyblue",
  "lightslategray",
  "lightslategrey",
  "lightsteelblue",
  "lightyellow",
  "lime",
  "limegreen",
  "linen",
  "magenta",
  "maroon",
  "mediumaquamarine",
  "mediumblue",
  "mediumorchid",
  "mediumpurple",
  "mediumseagreen",
  "mediumslateblue",
  "mediumspringgreen",
  "mediumturquoise",
  "mediumvioletred",
  "midnightblue",
  "mintcream",
  "mistyrose",
  "moccasin",
  "navajowhite",
  "navy",
  "oldlace",
  "olive",
  "olivedrab",
  "orange",
  "orangered",
  "orchid",
  "palegoldenrod",
  "palegreen",
  "paleturquoise",
  "palevioletred",
  "papayawhip",
  "peachpuff",
  "peru",
  "pink",
  "plum",
  "powderblue",
  "purple",
  "rebeccapurple",
  "red",
  "rosybrown",
  "royalblue",
  "saddlebrown",
  "salmon",
  "sandybrown",
  "seagreen",
  "seashell",
  "sienna",
  "silver",
  "skyblue",
  "slateblue",
  "slategray",
  "slategrey",
  "snow",
  "springgreen",
  "steelblue",
  "tan",
  "teal",
  "thistle",
  "tomato",
  "turquoise",
  "violet",
  "wheat",
  "white",
  "whitesmoke",
  "yellow",
  "yellowgreen"
];

// src/utils/colorUtils.ts
function isColor(color = "") {
  if (typeof color !== "string") {
    return false;
  }
  if (color.startsWith("#")) {
    color = color.substring(1);
    return [3, 4, 6, 8].indexOf(color.length) > -1 && !Number.isNaN(parseInt(color, 16));
  }
  const trimmedColor = color.trim();
  if (visualization_schemas_exports.rgbColorPattern.test(trimmedColor) || visualization_schemas_exports.rgbaColorPattern.test(trimmedColor)) {
    return true;
  }
  return namedColors_default.includes(color.toLowerCase());
}

// src/utils/types.ts
var supportedDateFormats = [
  "YYYY-MM-DD",
  // HTML5 date
  moment_default.ISO_8601,
  "YYYY-MM-DDTHH:mm",
  // HTML5 date local
  "YYYY-MM-DDTHH:mm:ss.SSS",
  // HTML5 date local milliseconds
  "YYYY-MM-DDTHH:mm:ss",
  // HTML5 date local seconds
  "YYYY-MM-DD HH:MM",
  "YYYY-MM-DD HH:MM:SS",
  "YYYY-MM-DD HH:MM:SS.SSS"
];
var typeOrder = [
  "geojson",
  "sparkline",
  "array",
  "string",
  "color",
  "number",
  "time",
  "null",
  "unknown"
];
function isNumber(dataPoint) {
  return dataPoint !== null && !(0, lodash_exports.isBoolean)(dataPoint) && dataPoint !== "" && (0, lodash_exports.isFinite)(+dataPoint) && (0, lodash_exports.isNumber)(+dataPoint);
}
function isGeoJsonObject(dataPoint) {
  if (!dataPoint) return false;
  let parsedDataPoint;
  try {
    parsedDataPoint = (0, lodash_exports.isObject)(dataPoint) ? dataPoint : JSON.parse(dataPoint);
  } catch (e) {
    return false;
  }
  if (parsedDataPoint == null) {
    return false;
  }
  return Object.prototype.hasOwnProperty.call(parsedDataPoint, "coordinates") && parsedDataPoint.coordinates != null && Array.isArray(parsedDataPoint.coordinates) && Object.prototype.hasOwnProperty.call(parsedDataPoint, "type") && parsedDataPoint.type === "MultiPolygon";
}
function isTime(dataPoint) {
  if (!dataPoint) {
    return false;
  }
  return typeof dataPoint === "string" ? moment_default(dataPoint, supportedDateFormats, true).isValid() : moment_default(dataPoint).isValid();
}
function isString(dataPoint) {
  return typeof dataPoint === "string" && dataPoint.length > 0;
}
var getDataTypeForPoint = (dataPoint, metaData) => {
  if (canInferTypeFromMeta(metaData)) {
    return getDataTypeForMeta(metaData);
  }
  return memoizedGetDataTypeForValue(dataPoint);
};
var getDataTypeForValue = (dataPoint) => {
  if (Array.isArray(dataPoint)) {
    if (dataPoint.length > 1 && dataPoint[0] === "##__SPARKLINE__##") {
      return "sparkline";
    }
    return "array";
  }
  if (isGeoJsonObject(dataPoint)) {
    return "geojson";
  }
  if ((0, lodash_exports.isObject)(dataPoint)) {
    return "unknown";
  }
  if (isNumber(dataPoint)) {
    return "number";
  }
  if (isString(dataPoint) && isColor(dataPoint)) {
    return "color";
  }
  if (isTime(dataPoint)) {
    return "time";
  }
  if (isString(dataPoint)) {
    return "string";
  }
  if (dataPoint === null) {
    return "null";
  }
  return "unknown";
};
var memoizedGetDataTypeForValue = (0, lodash_exports.memoize)(getDataTypeForValue);
var splTypesToDSLDataTypes = {
  str: "string",
  num: "number"
};
var canInferTypeFromMeta = (metaData = {}) => {
  const { name, type = "" } = metaData;
  return splTypesToDSLDataTypes[type] !== void 0 || name === "_time";
};
var getDataTypeForMeta = (metaData = {}) => {
  const { name, type } = metaData;
  if (name === "_time") {
    return "time";
  }
  const typeMatch = splTypesToDSLDataTypes[type];
  if (typeMatch !== void 0) {
    return typeMatch;
  }
  return "unknown";
};
var applyTypePrioritization = (typeMatches) => {
  const typesWithCount = Object.keys(typeMatches).filter(
    (key) => typeMatches[key] > 0
  );
  if (typesWithCount.length === 0) {
    return "unknown";
  }
  if (typesWithCount.length === 1) {
    return typesWithCount[0];
  }
  for (let i = 0; i < typeOrder.length; i += 1) {
    const key = typeOrder[i];
    if (typesWithCount.find((k) => k === key)) {
      return key;
    }
  }
  return "unknown";
};
var inferDataTypeFromDataPoints = (dataPoints) => {
  if (!dataPoints) {
    return "unknown";
  }
  const typeMatches = {
    time: 0,
    number: 0,
    string: 0,
    color: 0,
    unknown: 0,
    array: 0,
    sparkline: 0,
    null: 0,
    geojson: 0
  };
  dataPoints.forEach((point) => {
    typeMatches[point.getType()] += 1;
  });
  return applyTypePrioritization(typeMatches);
};

// src/utils/formatterUtils.ts
init_define_global();
var setDefaultValue = (defaultValue) => {
  if (isNumber(defaultValue)) {
    return defaultValue;
  }
  return defaultValue || "";
};
var timeToSplunkMoment = (time) => {
  if (moment_default.getDefaultSplunkTimezone()) {
    return moment_default.newSplunkTime({ time });
  }
  return moment_default(time);
};
var formatTimeWithTimezoneCorrection = (time, format = moment_default.defaultFormat) => {
  const utcOffset = moment_default.parseZone(time).utcOffset();
  const momentTime = timeToSplunkMoment(time).utcOffset(utcOffset);
  return momentTime.format(format);
};

// src/TypeSafeValue.ts
var TypeSafeValue = class _TypeSafeValue {
  // eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
  constructor(type, value, coercedValue) {
    /**
     * isTypeSafe. This is a marker field. The presence of this field can be used at runtime to determine if TypedValue is rigorous,
     * loose. Loose TypedValue such as {type:'number', value:'cat'} are handy for testing, but can lie. Obviously 'cat'
     * is not a number. If the isTypeSafe field is present then the instance is a TypeSafeValue
     * @type {boolean}
     */
    this.isTypeSafe = true;
    this.type = type;
    this.value = value;
    this.coercedValue = coercedValue;
  }
  /**
   * returns a TypeSafeValue, either by converting the non TypeSafeValue to
   * a TypeSafeValue, or by simply returning the passed-in TypeSafeValue
   * @param {TypedValue<T>} typedValue
   * @returns {TypeSafeValue<T>}
   */
  static from(typedValue) {
    if (typedValue.isTypeSafe) {
      return typedValue;
    }
    const { value, type } = typedValue;
    const [coercedValue] = _TypeSafeValue.coerceValue(typedValue);
    return new _TypeSafeValue(type, value, coercedValue);
  }
  /**
   * Creates a TypeSafeValue from a raw value
   * @param value
   * @returns {TypeSafeValue<DataType>}
   */
  static fromRaw(value) {
    const type = getDataTypeForPoint(value);
    return new _TypeSafeValue(type, value, value);
  }
  /**
   * attempts to coerce the provided value to the provided type. Returns tuple
   * of the coerced value and a boolean telling if the coercion was clean (true)
   * or if the coercion was likely produced an unusable result, such as NaN for
   * a number, or '' for a color.
   * @param {TypedValue<T>} typedValue
   * @returns {[any]}
   */
  static coerceValue(typedValue) {
    const { type, value } = typedValue;
    let coercedValue = null;
    try {
      switch (type) {
        case "number": {
          coercedValue = Number(value);
          break;
        }
        case "time": {
          const isOk = isTime(value);
          if (value instanceof Date) {
            coercedValue = value;
          } else if (!isOk) {
            coercedValue = "Invalid Date";
          } else {
            const timeString = formatTimeWithTimezoneCorrection(value);
            coercedValue = timeString;
          }
          break;
        }
        case "string": {
          coercedValue = value.toString();
          break;
        }
        case "color": {
          coercedValue = value;
          break;
        }
        case "sparkline": {
          coercedValue = value;
          break;
        }
        case "array": {
          coercedValue = value;
          break;
        }
        case "null": {
          coercedValue = value;
          break;
        }
        case "geojson": {
          coercedValue = value;
          break;
        }
        default: {
          coercedValue = "";
        }
      }
    } catch (e) {
    }
    return [coercedValue];
  }
  toRawCoercedValue() {
    switch (this.type) {
      case "time":
      case "sparkline":
      case "array":
      case "number":
      case "string":
      case "color":
      case "geojson":
      default:
        return this.coercedValue;
    }
  }
  toRawValue() {
    switch (this.type) {
      case "time":
      case "sparkline":
      case "array":
      case "number":
      case "string":
      case "color":
      case "geojson":
      default:
        return this.value;
    }
  }
};

// src/DataPoint.ts
var _DataPoint = class _DataPoint {
  static isDataPoint(o) {
    return o instanceof _DataPoint;
  }
  static fromRaw(value) {
    return new _DataPoint("", TypeSafeValue.fromRaw(value));
  }
  /**
   *
   * @param {string} field data field
   * @param {object} value data value + it's type (number, string, time, color, geojson)
   */
  constructor(field, value) {
    this.field = field;
    this.setValue(value);
    _DataPoint.count += 1;
  }
  getValue() {
    return this.value;
  }
  /**
   * Sets the data point's value to a static TypedValue.
   * @param {TypedValue} v
   */
  setValue(v) {
    this.value = TypeSafeValue.from(v);
  }
  /**
   * Get only value of the data point.
   * @returns {string|number|GeoJsonDataType|null}
   */
  getRawValue() {
    return this.value.toRawValue();
  }
  /**
   * Get only the coerced value of the data point.
   * @returns {string|number|null}
   */
  getCoercedValue() {
    return this.value.toRawCoercedValue();
  }
  /**
   * Returns the data field of the point.
   * @public
   * @returns {DataPoint<'string'>}
   */
  getField() {
    return _DataPoint.fromRaw(this.field);
  }
  /**
   * Returns the data type of the point.
   * @public
   * @returns {string}
   */
  getType() {
    return this.value.type;
  }
};
_DataPoint.count = 0;
var DataPoint = _DataPoint;

// src/DataSeries.ts
init_define_global();
var DataSeries = class _DataSeries {
  /**
   *
   * @param {array} points list of data points
   * @param {string} type user explicitly sets the data type
   */
  constructor(points = [], type, field) {
    this.internalPoints = [];
    this.internalPoints = points;
    if (points.length > 0) {
      this.field = points[0].field;
    }
    if (field) {
      this.field = field;
    }
    this.type = type;
  }
  get points() {
    return this.internalPoints;
  }
  static isDataSeries(o) {
    return o instanceof _DataSeries;
  }
  static fromRaw(pts) {
    return new _DataSeries(pts.map((p) => DataPoint.fromRaw(p)));
  }
  /**
   * Return first dataPoint in series.
   * @public
   * @returns {DataPoint}
   */
  firstPoint() {
    return this.points[0];
  }
  /**
   * Return last dataPoint in series.
   * @public
   * @returns {DataPoint}
   */
  lastPoint() {
    return this.points.slice(-1)[0];
  }
  /**
   * Finds dataPoint(s) in DataSeries by index(es).
   * @public
   * @param {...number} indexes
   * @returns {DataSeries}
   */
  pointsByIndexes(...indexes) {
    const indexedPoints = [];
    indexes.forEach((index) => {
      const dp = this.points[index];
      if (dp != null) {
        indexedPoints.push(dp);
      }
    });
    return new _DataSeries(indexedPoints);
  }
  /**
   * Finds and returns the individual dataPoint at the given index.
   * @public
   * @param {number} index
   * @returns {DataPoint}
   */
  pointByIndex(indexIn) {
    let index = indexIn;
    if (index < 0) {
      index = this.points.length + index;
    }
    if (index < 0 || index >= this.points.length) {
      return null;
    }
    const dp = this.points[index];
    const { field } = dp;
    const { type, value } = dp.getValue();
    return new DataPoint(field, { type, value });
  }
  /**
   * Finds the delta between the last point and point at the given index.
   * A negative index can be used, indicating an offset from the end of the sequence.
   * @public
   * @param {number} index
   * @returns {DataPoint}
   */
  delta(index) {
    const dp1 = this.lastPoint();
    if (dp1 === void 0) {
      return void 0;
    }
    const { field } = dp1;
    const { type, value: val1 } = dp1.getValue();
    if (type !== "number") {
      console.warn(`DSL delta cannot be computed for non-numerical data series of type ${type}`);
    }
    let dp2 = null;
    let delta;
    if (index >= 0) {
      dp2 = this.points[index];
    } else {
      dp2 = this.points.slice().reverse()[Math.abs(index) - 1];
    }
    if (dp2 == null) {
      console.warn("DSL delta cannot be computed, no data - invalid index");
    } else {
      const { value: val2 } = dp2.getValue();
      delta = val1 - val2;
    }
    return new DataPoint(field, { type, value: delta });
  }
  /**
   * Sets all the values in the Data Series to a static TypedValue.
   * @param {TypedValue} v
   */
  setValue(v) {
    this.points.forEach((p) => {
      p.setValue(v);
    });
    this.type = this.points[0].getType();
  }
  /**
   * Gets all the values + their type in the Data Series.
   * @returns {TypedValue[]}
   */
  getValue() {
    const values = [];
    this.points.forEach((p) => {
      values.push(p.getValue());
    });
    return values;
  }
  /**
   * Gets all the values (only) in the Data Series.
   * @returns {array}
   */
  getRawValue() {
    const values = [];
    this.points.forEach((p) => {
      values.push(p.getRawValue());
    });
    return values;
  }
  /**
   * Returns the data source field which the series belongs to.
   * @public
   * @returns {DataPoint<'string'>}
   */
  getField() {
    const dp1 = this.lastPoint();
    return dp1.getField();
  }
  /**
   * Returns the inferred data type of the series.
   * @public
   * @returns {string}
   */
  getType() {
    if (this.type === void 0) {
      this.type = inferDataTypeFromDataPoints(this.points);
    }
    return this.type;
  }
  /**
   * Returns the minimum DataPoint in the series or undefined if no numbers in series.
   * @public
   * @returns {DataPoint<T>}
   */
  min() {
    return this.reduce((v1, v2) => v1 < v2);
  }
  /**
   * Returns the maximum DataPoint in the series.
   * @public
   * @returns {DataPoint<T>}
   */
  max() {
    return this.reduce((v1, v2) => v1 > v2);
  }
  reduce(comparator) {
    return this.points.reduce((agg, cur) => {
      return !agg || comparator(cur.getValue().coercedValue, agg.getValue().coercedValue) ? cur : agg;
    }, void 0);
  }
};

// src/DataFrame.ts
init_define_global();
var DataFrame = class _DataFrame {
  /**
   * @param {any} o
   * @returns {boolean}
   */
  static isDataFrame(o) {
    return o instanceof _DataFrame;
  }
  /**
   * @param {array} series list of data series
   */
  constructor(series) {
    this.series = Array.isArray(series) ? series : [series];
  }
  /**
   * Loads ColumnarData into a DataFrame
   * @param {ColumnarData} columnarData
   * @returns {DataFrame<T>}
   */
  static fromJsonCols(columnarData) {
    if (!(columnarData == null ? void 0 : columnarData.data)) {
      return new _DataFrame([]);
    }
    const {
      data: { fields = [], columns = [] }
    } = columnarData;
    if (columns.length !== fields.length) {
      throw new Error(
        `number of columns (${columns.length}) does not match number of fields (${fields.length})`
      );
    }
    const dataSeries = [];
    columns.forEach((data, idx) => {
      const dataPoints = [];
      const fieldInfo = fields[idx];
      const name = fieldInfo.name || fieldInfo;
      const type = fieldInfo == null ? void 0 : fieldInfo.type;
      data.forEach((value) => {
        const dataType = getDataTypeForPoint(value, { name, type });
        dataPoints.push(new DataPoint(name, { value, type: dataType }));
      });
      dataSeries.push(new DataSeries(dataPoints));
    });
    return new _DataFrame(dataSeries);
  }
  static fromRaw(f) {
    const series = [];
    f.forEach((s) => {
      series.push(DataSeries.fromRaw(s));
    });
    return new _DataFrame(series);
  }
  // eslint-disable-next-line consistent-return
  static fromDataPrimitive(dp) {
    if (_DataFrame.isDataFrame(dp)) {
      return dp;
    }
    if (DataSeries.isDataSeries(dp)) {
      return new _DataFrame([dp]);
    }
    if (DataPoint.isDataPoint(dp)) {
      return new _DataFrame([new DataSeries([dp])]);
    }
  }
  /**
   * Filter a DataFrame by specifying the indexes of the DataSeries you would like to return.
   * For example, `frameBySeriesIndexes(first_index, second_index, ...)`, where at least one index is required.
   * @public
   * @param {number[]} indexes
   * @returns {DataFrame.<DataType>}
   *
   * The following code sample shows how to use frameBySeriesIndexes to render a table that includes the first, second, and fourth DataSeries from the data source.
   *
   * ```
   * <Table
   *   options={{
   *     table: '> primary | frameBySeriesIndexes(0,1,3)'
   *   }},
   *   dataSources={{
   *     primary: {
   *       data: {
   *         fields: [
   *           {
   *             name: 'Name'
   *           },
   *           {
   *             name: 'UserID'
   *           },
   *           {
   *             name: 'Money Spent'
   *           },
   *           {
   *             name: 'Most Recent Game'
   *           }
   *         ],
   *         columns: [
   *           [
   *             'Ms. Herman Beer',
   *             'Crystal Ziemann',
   *             'Phil Bartoletti',
   *             'Janis Kiehn V',
   *             'Angel Krajcik',
   *             'Patti Hodkiewicz IV',
   *             'Joanne Emmerich',
   *             'Jay Renner',
   *             'Ora Borer',
   *             'Dr. Bradford Gulgowski'
   *           ],
   *           [
   *             'Enrico98',
   *             'Taylor_Parker83',
   *             'Candice_Carroll',
   *             'Yolanda_McLaughlin95',
   *             'Modesto84',
   *             'Elwin52',
   *             'Francis8',
   *             'Charley.Feeney85',
   *             'Jensen_Jacobson74',
   *             'Dora_Volkman'
   *           ],
   *           [
   *             9740890.83,
   *             2107983.52,
   *             5467223.67,
   *             9529184.93,
   *             9692275.78,
   *             5692737.43,
   *             1001734.82,
   *             3848531.8,
   *             3848531.8
   *           ],
   *           [
   *             '2020-04-12T06:32:08-07:00',
   *             '2020-06-06T16:14:04-07:00',
   *             '2020-02-12T09:43:25-08:00',
   *             '2020-07-25T13:19:49-07:00',
   *             '2020-03-16T21:46:40-07:00',
   *             '2020-08-21T08:38:55-07:00',
   *             '2020-09-26T16:06:03-07:00',
   *             '2020-08-10T14:54:16-07:00',
   *             '2020-08-11T16:49:24-07:00',
   *             '2020-09-29T03:52:51-07:00'
   *           ]
   *         ]
   *       },
   *       meta: {
   *         totalCount: 100
   *       },
   *       requestParams: {
   *         count: 10,
   *         offset: 0
   *       }
   *     }
   *   }}
   * />
   */
  frameBySeriesIndexes(...indexes) {
    const indexedSeries = [];
    indexes.forEach((index) => {
      const ds = this.series[index];
      if (ds != null) {
        indexedSeries.push(ds);
      }
    });
    return new _DataFrame(indexedSeries);
  }
  /**
   * Select a DataSeries by specifying the index of the series you want to return.
   * @public
   * @param {number} index
   * @returns {DataSeries<DataType>}
   *
   * The following code sample shows how to use seriesByIndex to display the second series in a data source as a single value.
   *
   * ```
   * <SingleValue
   *     options={{
   *         sparklineValues: '> primary | seriesByIndex(1)'
   *     }}
   *     dataSources={{
   *         primary: {
   *             data: {
   *                 fields: [
   *                     {
   *                         name: '_time',
   *                     },
   *                     {
   *                         name: 'count',
   *                     },
   *                 ],
   *                 columns: [
   *                     [
   *                         '2018-08-19T00:00:00.000+00:00',
   *                         '2018-08-20T00:00:00.000+00:00',
   *                         '2018-08-21T00:00:00.000+00:00',
   *                         '2018-08-22T00:00:00.000+00:00',
   *                         '2018-08-23T00:00:00.000+00:00',
   *                         '2018-08-24T00:00:00.000+00:00',
   *                         '2018-08-25T00:00:00.000+00:00',
   *                         '2018-08-26T00:00:00.000+00:00',
   *                     ],
   *                     ['1', '62', '103', '308', '587', '876', '930', '1320'],
   *                 ],
   *             },
   *             meta: {},
   *         },
   *     }}
   * />
   *
   */
  // SCP-60632: added a second parameter - empty array as default fallback, hidden from user
  seriesByIndex(index, defaultSeries = []) {
    return this.series[index] || defaultSeries;
  }
  /**
   * Filter a DataFrame by specifying the index range [start, end) of the DataSeries you would like to return.
   * For example, `frameBySeriesIndexRange(start_index)` or `frameBySeriesIndexRange(start_index, end_index)`, where at least the starting index is required.
   * @public
   * @param {int} start (inclusive)
   * @param {int=} end (optional, exclusive)
   * @returns {DataFrame<DataType>}
   *
   * The following code sample shows how to use frameBySeriesIndexRange to render a table that includes the first, second, and third series from the data source.
   *
   * ```
   * <Table
   *   options={{
   *     table: '> primary | frameBySeriesIndexRange(0,2)'
   *   }},
   *   dataSources={{
   *     primary: {
   *       data: {
   *         fields: [
   *           {
   *             name: 'Name'
   *           },
   *           {
   *             name: 'UserID'
   *           },
   *           {
   *             name: 'Money Spent'
   *           },
   *           {
   *             name: 'Most Recent Game'
   *           },
   *         ],
   *         columns: [
   *           [
   *             'Ms. Herman Beer',
   *             'Crystal Ziemann',
   *             'Phil Bartoletti',
   *             'Janis Kiehn V',
   *             'Angel Krajcik',
   *             'Patti Hodkiewicz IV',
   *             'Joanne Emmerich',
   *             'Jay Renner',
   *             'Ora Borer',
   *             'Dr. Bradford Gulgowski'
   *           ],
   *           [
   *             'Enrico98',
   *             'Taylor_Parker83',
   *             'Candice_Carroll',
   *             'Yolanda_McLaughlin95',
   *             'Modesto84',
   *             'Elwin52',
   *             'Francis8',
   *             'Charley.Feeney85',
   *             'Jensen_Jacobson74',
   *             'Dora_Volkman'
   *           ],
   *           [
   *             9740890.83,
   *             2107983.52,
   *             5467223.67,
   *             9529184.93,
   *             9692275.78,
   *             9395814.7,
   *             5692737.43,
   *             1001734.82,
   *             3848531.8,
   *             1691776.38
   *           ],
   *           [
   *             '2020-04-12T06:32:08-07:00',
   *             '2020-06-06T16:14:04-07:00',
   *             '2020-02-12T09:43:25-08:00',
   *             '2020-07-25T13:19:49-07:00',
   *             '2020-03-16T21:46:40-07:00',
   *             '2020-08-21T08:38:55-07:00',
   *             '2020-09-26T16:06:03-07:00',
   *             '2020-08-10T14:54:16-07:00',
   *             '2020-08-11T16:49:24-07:00',
   *             '2020-09-29T03:52:51-07:00'
   *           ]
   *         ]
   *       },
   *       meta: {
   *         totalCount: 100
   *       },
   *       requestParams: {
   *         count: 10,
   *         offset: 0
   *       }
   *     }
   *   }}
   * />
   */
  frameBySeriesIndexRange(start, end) {
    return new _DataFrame(this.series.slice(start, end));
  }
  /**
   * Filter a DataFrame by specifying the names of the DataSeries you would like to return.
   * For example, `frameBySeriesNames(first_name, second_name, ...)`, where at least one series name is required.
   * @public
   * @param {string[]} names
   * @returns {DataFrame<DataType>}
   *
   * The following code sample shows how to use frameBySeriesNames to render a table with the Name and Money Spent columns in the data source.
   *
   * ```
   * <Table
   *     options={{
   *         table: '> primary | frameBySeriesNames("Name", "Money Spent")'
   *     }},
   *     dataSources={{
   *         primary: {
   *             data: {
   *                 fields: [
   *                     {
   *                         name: 'Name'
   *                     },
   *                     {
   *                         name: 'UserID'
   *                     },
   *                     {
   *                         name: 'Money Spent'
   *                     },
   *                     {
   *                         name: 'Most Recent Game'
   *                     },
   *                 ],
   *                 columns: [
   *                     [
   *                         'Ms. Herman Beer',
   *                         'Crystal Ziemann',
   *                         'Phil Bartoletti',
   *                         'Janis Kiehn V',
   *                         'Angel Krajcik',
   *                         'Patti Hodkiewicz IV',
   *                         'Joanne Emmerich',
   *                         'Jay Renner',
   *                         'Ora Borer',
   *                         'Dr. Bradford Gulgowski'
   *                     ],
   *                     [
   *                         'Enrico98',
   *                         'Taylor_Parker83',
   *                         'Candice_Carroll',
   *                         'Yolanda_McLaughlin95',
   *                         'Modesto84',
   *                         'Elwin52',
   *                         'Francis8',
   *                         'Charley.Feeney85',
   *                         'Jensen_Jacobson74',
   *                         'Dora_Volkman'
   *                     ],
   *                     [
   *                         9740890.83,
   *                         2107983.52,
   *                         5467223.67,
   *                         9529184.93,
   *                         9692275.78,
   *                         9395814.7,
   *                         5692737.43,
   *                         1001734.82,
   *                         3848531.8,
   *                         1691776.38
   *                     ],
   *                     [
   *                         '2020-04-12T06:32:08-07:00',
   *                         '2020-06-06T16:14:04-07:00',
   *                         '2020-02-12T09:43:25-08:00',
   *                         '2020-07-25T13:19:49-07:00',
   *                         '2020-03-16T21:46:40-07:00',
   *                         '2020-08-21T08:38:55-07:00',
   *                         '2020-09-26T16:06:03-07:00',
   *                         '2020-08-10T14:54:16-07:00',
   *                         '2020-08-11T16:49:24-07:00',
   *                         '2020-09-29T03:52:51-07:00'
   *                     ]
   *                 ]
   *             },
   *             meta: {
   *                 totalCount: 100
   *             },
   *             requestParams {
   *                 count: 10,
   *                 offset: 0
   *             }
   *         }
   *     }}
   * />
   */
  frameBySeriesNames(...names) {
    const namedSeries = [];
    names.forEach((name) => {
      const series = this.seriesByName(name);
      const found = series && DataSeries.isDataSeries(series);
      if (found) {
        namedSeries.push(series);
      }
    });
    return new _DataFrame(namedSeries);
  }
  /**
   * Filter a DataFrame by specifying the names of the DataSeries you would like to omit.
   *  e.g. `frameWithoutSeriesNames(first_name, second_name, ...)`, where at least one series name is required.
   * Note: the data columns of internal fields are automatically excluded from the result.
   * @public
   * @param {string[]} names
   * @returns {DataFrame<DataType>}
   */
  frameWithoutSeriesNames(...names) {
    if (names == null) {
      return new _DataFrame(this.series);
    }
    return new _DataFrame(
      this.series.filter(
        (s) => !names.includes(s.field) && !s.field.startsWith("_")
      )
    );
  }
  /**
   * Filter a DataFrame by removing all internal fields starting with underscore `_`.
   * For example, if you have a primary data source with the following fields: `_time, _span, date, count, cost, _raw`,
   * then DSL `> primary | frameWithoutInternalFields()` removes all the internal fields and returns the DataFrame with fields `date, count, cost`.
   * @public
   * @returns {DataFrame<DataType>}
   *
   * The following code sample shows how to use `frameWithoutInternalFields()` to remove the internal fields from the data source.
   *
   * ```
   * <Table
   *     options={{
   *         table: '> primary | frameWithoutInternalFields()'
   *     }},
   *     dataSources={{
   *         primary: {
   *             data: {
   *                 fields: [
   *                     {
   *                         name: 'Name'
   *                     },
   *                     {
   *                         name: 'UserID'
   *                     },
   *                     {
   *                         name: '_time'
   *                     },
   *                     {
   *                         name: '_span'
   *                     },
   *                 ],
   *                 columns: [
   *                     [
   *                         'Ms. Herman Beer',
   *                         'Crystal Ziemann',
   *                         'Jay Renner',
   *                         'Ora Borer',
   *                         'Dr. Bradford Gulgowski'
   *                     ],
   *                     [
   *                         'Enrico98',
   *                         'Taylor_Parker83',
   *                         'Charley.Feeney85',
   *                         'Jensen_Jacobson74',
   *                         'Dora_Volkman'
   *                     ],
   *                     [
   *                         '2020-04-12T06:32:08-07:00',
   *                         '2020-06-06T16:14:04-07:00',
   *                         '2020-08-10T14:54:16-07:00',
   *                         '2020-08-11T16:49:24-07:00',
   *                         '2020-09-29T03:52:51-07:00'
   *                     ],
   *                     [
   *                         '1800',
   *                         '1800',
   *                         '1800',
   *                         '1800',
   *                         '1800'
   *                     ]
   *                 ]
   *             },
   *             meta: {
   *                 totalCount: 100
   *             },
   *             requestParams {
   *                 count: 10,
   *                 offset: 0
   *             }
   *         }
   *     }}
   * />
   * ```
   * This code sample will visualize a table with the `Name` and `UserID` columns,
   * and the columns of `_time` and `_span` (internal fields) will not be displayed.
   *
   * Another example of using `frameWithoutInternalFields()` in a chained DSL:
   *
   * ```
   * <SingleValue
   *     options={{
   *         "majorValue": "> primary | frameWithoutInternalFields() | seriesByIndex(0) | lastPoint()"
   *     }},
   *     dataSources={{
   *         primary: {
   *             data: {
   *                 fields: [
   *                     {
   *                         name: '_time'
   *                     },
   *                     {
   *                         name: '_span'
   *                     },
   *                     {
   *                         name: 'Name'
   *                     },
   *                     {
   *                         name: 'UserID'
   *                     }
   *                 ],
   *                 columns: [
   *                     [
   *                         '2020-04-12T06:32:08-07:00',
   *                         '2020-06-06T16:14:04-07:00',
   *                         '2020-08-10T14:54:16-07:00',
   *                         '2020-08-11T16:49:24-07:00',
   *                         '2020-09-29T03:52:51-07:00'
   *                     ],
   *                     [
   *                         '1800',
   *                         '1800',
   *                         '1800',
   *                         '1800',
   *                         '1800'
   *                     ],
   *                     [
   *                         'Patti Hodkiewicz IV',
   *                         'Joanne Emmerich',
   *                         'Jay Renner',
   *                         'Ora Borer',
   *                         'Dr. Bradford Gulgowski'
   *                     ],
   *                     [
   *                         'Elwin52',
   *                         'Francis8',
   *                         'Charley.Feeney85',
   *                         'Jensen_Jacobson74',
   *                         'Dora_Volkman'
   *                     ]
   *                 ]
   *             },
   *             meta: {
   *                 totalCount: 100
   *             },
   *             requestParams {
   *                 count: 10,
   *                 offset: 0
   *             }
   *         }
   *     }}
   * />
   * ```
   * This code sample will visualize `Dr. Bradford Gulgowski` as the major value,
   * because both internal fields (`_time` and `_span`) are removed and index `0` of the rest of the data frame corresponds to the `Name` column.
   */
  frameWithoutInternalFields() {
    return new _DataFrame(
      this.series.filter((s) => !s.field.startsWith("_"))
    );
  }
  /**
   * Filter a DataFrame by removing all internal fields starting with underscore `_`, except for the fields listed in `names`.
   * For example, if you have a primary data source with the following fields: `_time, _span, date, count, cost, _raw`,
   * then DSL `> primary | frameWithoutInternalFields('_time')` removes all the internal fields except `_time` and returns the DataFrame with fields `_time, date, count, cost`.
   * If you want to remove all the internal fields, use `frameWithoutInternalFields()` instead.
   * If you pass any non-internal fields as parameters, they will be ignored.
   *
   * @public
   * @param {string[]} names
   * @returns {DataFrame<DataType>}
   *
   * The following code sample shows how to use `frameWithoutInternalFieldsExcept(...names)` to remove some internal fields from the data source, but leaving specified internal fields by their field names.
   *
   * ```
   * <Table
   *     options={{
   *         table: '> primary | frameWithoutInternalFieldsExcept('_time', '_span')'
   *     }},
   *     dataSources={{
   *         primary: {
   *             data: {
   *                 fields: [
   *                     {
   *                         name: 'Name'
   *                     },
   *                     {
   *                         name: 'UserID'
   *                     },
   *                     {
   *                         name: '_time'
   *                     },
   *                     {
   *                         name: '_span'
   *                     },
   *                     {
   *                         name: '_raw'
   *                     },
   *                 ],
   *                 columns: [
   *                     [
   *                         'Ms. Herman Beer',
   *                         'Joanne Emmerich',
   *                         'Jay Renner',
   *                         'Ora Borer',
   *                         'Dr. Bradford Gulgowski'
   *                     ],
   *                     [
   *                         'Enrico98',
   *                         'Francis8',
   *                         'Charley.Feeney85',
   *                         'Jensen_Jacobson74',
   *                         'Dora_Volkman'
   *                     ],
   *                     [
   *                         '2020-04-12T06:32:08-07:00',
   *                         '2020-09-26T16:06:03-07:00',
   *                         '2020-08-10T14:54:16-07:00',
   *                         '2020-08-11T16:49:24-07:00',
   *                         '2020-09-29T03:52:51-07:00'
   *                     ],
   *                     [
   *                         '1800',
   *                         '1800',
   *                         '1800',
   *                         '1800',
   *                         '1800'
   *                     ],
   *                     [
   *                         '2020-04-12T06:32:08-07:00',
   *                         '2020-09-26T16:06:03-07:00',
   *                         '2020-08-10T14:54:16-07:00',
   *                         '2020-08-11T16:49:24-07:00',
   *                         '2020-09-29T03:52:51-07:00'
   *                     ]
   *                 ]
   *             },
   *             meta: {
   *                 totalCount: 100
   *             },
   *             requestParams {
   *                 count: 10,
   *                 offset: 0
   *             }
   *         }
   *     }}
   * />
   * ```
   *
   * This code sample will visualize the table with the `Name`, `UserID`, `_time` and `_span` columns,
   * and the `_raw` columns will not be displayed.
   *
   * Another example of using `frameWithoutInternalFieldsExcept(...names)` in a chained DSL:
   *
   * ```
   * <SingleValue
   *     options={{
   *         "majorValue": "> primary | frameWithoutInternalFieldsExcept('_time') | seriesByIndex(1) | lastPoint()"
   *     }},
   *     dataSources={{
   *         primary: {
   *             data: {
   *                 fields: [
   *                     {
   *                         name: '_time'
   *                     },
   *                     {
   *                         name: '_span'
   *                     },
   *                     {
   *                         name: '_raw'
   *                     },
   *                     {
   *                         name: 'Name'
   *                     },
   *                     {
   *                         name: 'UserID'
   *                     }
   *                 ],
   *                 columns: [
   *                     [
   *                         '2020-04-12T06:32:08-07:00',
   *                         '2020-09-26T16:06:03-07:00',
   *                         '2020-08-10T14:54:16-07:00',
   *                         '2020-08-11T16:49:24-07:00',
   *                         '2020-09-29T03:52:51-07:00'
   *                     ],
   *                     [
   *                         '1800',
   *                         '1800',
   *                         '1800',
   *                         '1800',
   *                         '1800'
   *                     ],
   *                     [
   *                         '2020-04-12T06:32:08-07:00',
   *                         '2020-06-06T16:14:04-07:00',
   *                         '2020-08-10T14:54:16-07:00',
   *                         '2020-08-11T16:49:24-07:00',
   *                         '2020-09-29T03:52:51-07:00'
   *                     ],
   *                     [
   *                         'Ms. Herman Beer',
   *                         'Crystal Ziemann',
   *                         'Angel Krajcik',
   *                         'Jay Renner',
   *                         'Dr. Bradford Gulgowski'
   *                     ],
   *                     [
   *                         'Candice_Carroll',
   *                         'Elwin52',
   *                         'Francis8',
   *                         'Charley.Feeney85',
   *                         'Dora_Volkman'
   *                     ]
   *                 ]
   *             },
   *             meta: {
   *                 totalCount: 100
   *             },
   *             requestParams {
   *                 count: 10,
   *                 offset: 0
   *             }
   *         }
   *     }}
   * />
   * ```
   *
   * This code sample will visualize `Dr. Bradford Gulgowski` as the major value, because the internal fields other than `_time` are excluded,
   * and index `1` of the rest of the data frame (`_time`, `Name`, `UserID`) corresponds to the `Name` column.
   */
  frameWithoutInternalFieldsExcept(...names) {
    if (!names || names.length === 0) {
      return this.frameWithoutInternalFields();
    }
    const fields = this.series.map((s) => s.field);
    const validNames = names.filter((name) => fields.includes(name));
    return new _DataFrame(
      this.series.filter(
        (s) => validNames.includes(s.field) || !s.field.startsWith("_")
      )
    );
  }
  /**
   * Filter a DataFrame by specifying one or more names or indexes of DataSeries you would like to return.
   * For example,`frameBySeriesNames(first_name_or_index, second_name_or_index, ...)`, where at least one name or index is required.
   * @public
   * @param {...(string|number)} namesOrIndexes
   * @returns {DataFrame<DataType>}
   *
   * The following code sample shows how to use frameBySeriesNamesOrIndexes to render a table with the Name DataSeries and the fourth DataSeries in the data source.
   *
   * ```
   * <Table
   *     options={{
   *         table: '> primary | frameBySeriesNamesOrIndexes("Name", 3)'
   *     }},
   *     dataSources={{
   *         primary: {
   *             data: {
   *                 fields: [
   *                     {
   *                         name: 'Name'
   *                     },
   *                     {
   *                         name: 'UserID'
   *                     },
   *                     {
   *                         name: 'Money Spent'
   *                     },
   *                     {
   *                         name: 'Most Recent Game'
   *                     },
   *                 ],
   *                 columns: [
   *                     [
   *                         'Ms. Herman Beer',
   *                         'Crystal Ziemann',
   *                         'Phil Bartoletti',
   *                         'Janis Kiehn V',
   *                         'Angel Krajcik',
   *                         'Patti Hodkiewicz IV',
   *                         'Joanne Emmerich',
   *                         'Jay Renner',
   *                         'Ora Borer',
   *                         'Dr. Bradford Gulgowski'
   *                     ],
   *                     [
   *                         'Enrico98',
   *                         'Taylor_Parker83',
   *                         'Candice_Carroll',
   *                         'Yolanda_McLaughlin95',
   *                         'Modesto84',
   *                         'Elwin52',
   *                         'Francis8',
   *                         'Charley.Feeney85',
   *                         'Jensen_Jacobson74',
   *                         'Dora_Volkman'
   *                     ],
   *                     [
   *                         9740890.83,
   *                         2107983.52,
   *                         5467223.67,
   *                         9529184.93,
   *                         9692275.78,
   *                         9395814.7,
   *                         5692737.43,
   *                         1001734.82,
   *                         3848531.8,
   *                         1691776.38
   *                     ],
   *                     [
   *                         '2020-04-12T06:32:08-07:00',
   *                         '2020-06-06T16:14:04-07:00',
   *                         '2020-02-12T09:43:25-08:00',
   *                         '2020-07-25T13:19:49-07:00',
   *                         '2020-03-16T21:46:40-07:00',
   *                         '2020-08-21T08:38:55-07:00',
   *                         '2020-09-26T16:06:03-07:00',
   *                         '2020-08-10T14:54:16-07:00',
   *                         '2020-08-11T16:49:24-07:00',
   *                         '2020-09-29T03:52:51-07:00',
   *                     ]
   *                 ]
   *             },
   *             meta: {
   *                 totalCount: 100
   *             },
   *             requestParams: {
   *                 count: 10,
   *                 offset: 0
   *             }
   *         }
   *     }}
   * />
   */
  frameBySeriesNamesOrIndexes(...mixed) {
    const mixedSeries = [];
    mixed.forEach((nameOrIndex) => {
      const asNumber = Number(nameOrIndex);
      if (Number.isNaN(asNumber)) {
        const found = this.seriesByName(nameOrIndex);
        if (found) {
          mixedSeries.push(found);
        }
      } else {
        const found = this.series[asNumber];
        if (found) {
          mixedSeries.push(found);
        }
      }
    });
    return new _DataFrame(mixedSeries);
  }
  /**
   * Filter a DataFrame by specifying one or more types of DataSeries you would like to return.
   * For example, `frameBySeriesNames(first_type, second_type, ...)`, where at least one type is required.
   * @public
   * @param {DataType[]} types
   * @returns {DataFrame<DataType>}
   *
   * The following code sample shows how to use frameBySeriesTypes to render a table that contains only the string columns in the data source.
   *
   * ```
   * <Table
   *     options={{
   *         table: '> primary | frameBySeriesTypes("string")'
   *     }},
   *     dataSources={{
   *         primary: {
   *             data: {
   *                 fields: [
   *                     {
   *                         name: 'Name'
   *                     },
   *                     {
   *                         name: 'UserID'
   *                     },
   *                     {
   *                         name: 'Money Spent'
   *                     },
   *                     {
   *                         name: 'Most Recent Game'
   *                     },
   *                 ],
   *                 columns: [
   *                     [
   *                         'Ms. Herman Beer',
   *                         'Crystal Ziemann',
   *                         'Phil Bartoletti',
   *                         'Janis Kiehn V',
   *                         'Angel Krajcik',
   *                         'Patti Hodkiewicz IV',
   *                         'Joanne Emmerich',
   *                         'Jay Renner',
   *                         'Ora Borer',
   *                         'Dr. Bradford Gulgowski'
   *                     ],
   *                     [
   *                         'Enrico98',
   *                         'Taylor_Parker83',
   *                         'Candice_Carroll',
   *                         'Yolanda_McLaughlin95',
   *                         'Modesto84',
   *                         'Elwin52',
   *                         'Francis8',
   *                         'Charley.Feeney85',
   *                         'Jensen_Jacobson74',
   *                         'Dora_Volkman'
   *                     ],
   *                     [
   *                         9740890.83,
   *                         2107983.52,
   *                         5467223.67,
   *                         9529184.93,
   *                         9692275.78,
   *                         9395814.7,
   *                         5692737.43,
   *                         1001734.82,
   *                         3848531.8,
   *                         1691776.38
   *                     ],
   *                     [
   *                         '2020-04-12T06:32:08-07:00',
   *                         '2020-06-06T16:14:04-07:00',
   *                         '2020-02-12T09:43:25-08:00',
   *                         '2020-07-25T13:19:49-07:00',
   *                         '2020-03-16T21:46:40-07:00',
   *                         '2020-08-21T08:38:55-07:00',
   *                         '2020-09-26T16:06:03-07:00',
   *                         '2020-08-10T14:54:16-07:00',
   *                         '2020-08-11T16:49:24-07:00',
   *                         '2020-09-29T03:52:51-07:00'
   *                     ]
   *                 ]
   *             },
   *             meta: {
   *                 totalCount: 100
   *             },
   *             requestParams: {
   *                 count: 10,
   *                 offset: 0
   *             }
   *         }
   *     }}
   * />
   */
  frameBySeriesTypes(...types) {
    return new _DataFrame(
      this.series.filter((s) => types.includes(s.getType()))
    );
  }
  /**
   * Select a DataSeries by specifying the name of the DataSeries you would like to return.
   * @public
   * @param {string} field
   * @returns {DataSeries<DataType>}
   *
   * The following code sample shows how to use seriesByName to display the count series in a data source as a single value.
   *
   * ```
   * <SingleValue
   *     options={{
   *         sparklineValues: '> primary | seriesByName("count")',
   *     }}
   *     dataSources={{
   *         primary: {
   *             data: {
   *                 fields: [
   *                     {
   *                         name: '_time',
   *                     },
   *                     {
   *                         name: 'count',
   *                     },
   *                 ],
   *                 columns: [
   *                     [
   *                         '2018-08-19T00:00:00.000+00:00',
   *                         '2018-08-20T00:00:00.000+00:00',
   *                         '2018-08-21T00:00:00.000+00:00',
   *                         '2018-08-22T00:00:00.000+00:00',
   *                         '2018-08-23T00:00:00.000+00:00',
   *                         '2018-08-24T00:00:00.000+00:00',
   *                         '2018-08-25T00:00:00.000+00:00',
   *                         '2018-08-26T00:00:00.000+00:00',
   *                     ],
   *                     ['1', '62', '103', '308', '587', '876', '930', '1320'],
   *                 ],
   *             },
   *             meta: {},
   *         },
   *     }}
   * />
   */
  // SCP-60632: added a second parameter - empty array as default fallback, hidden from user
  seriesByName(field, defaultSeries = []) {
    var _a;
    return (_a = this.series.find((dataSeries) => field === dataSeries.field)) != null ? _a : defaultSeries;
  }
  /**
   * Select a DataSeries by specifying the type of the DataSeries you would like to return. The first DataSeries that matches the first type specified will be returned. If no DataSeries matches the first type specified, no DataSeries will be returned.
   * @public
   * @param {DataType} type
   * @returns {DataSeries<DataType>}
   *
   * The following code sample shows how to use seriesByType to display the first numeric series in a data source as a single value.
   *
   * If no numeric series are found, return nothing and display N/A.
   *
   * ```
   * <SingleValue
   *     options={{
   *         sparklineValues: '> primary | seriesByType("number")',
   *     }}
   *     dataSources: {{
   *         primary: {
   *             data: {
   *                 fields: [
   *                     {
   *                         name: '_time",
   *                     },
   *                     {
   *                         name: 'count',
   *                     },
   *                 ],
   *                 columns: [
   *                     [
   *                         '2018-08-19T00:00:00.000+00:00',
   *                         '2018-08-20T00:00:00.000+00:00',
   *                         '2018-08-21T00:00:00.000+00:00',
   *                         '2018-08-22T00:00:00.000+00:00',
   *                         '2018-08-23T00:00:00.000+00:00',
   *                         '2018-08-24T00:00:00.000+00:00',
   *                         '2018-08-25T00:00:00.000+00:00',
   *                         '2018-08-26T00:00:00.000+00:00',
   *                     ],
   *                     [ '1', '62', '103', '308', '587', '876', '930', '1320'],
   *                 ],
   *             },
   *             meta: {},
   *         },
   *     }}
   * />
   */
  seriesByType(type) {
    return this.series.find((dataSeries) => {
      const dataType = dataSeries.getType();
      return dataType === type;
    });
  }
  /**
   * Select a DataSeries by specifying any acceptable types of the DataSeries you would like to return. The first DataSeries that matches any of the types specified will be returned. If no DataSeries matches the type options specified, no DataSeries will be returned.
   * @public
   * @param {DataType[]} types
   * @returns {DataSeries<DataType>}
   */
  seriesByTypes(...types) {
    return this.series.find(
      (dataSeries) => types.some((type) => dataSeries.getType() === type)
    );
  }
  /**
   * Select a DataSeries by specifying the prioritized types of the DataSeries you would like to return. The first DataSeries that matches the first type specified will be returned. If no DataSeries matches the first type specified, the first DataSeries that matches the second type will be returned, and so on.
   * @public
   * @param {DataType[]} types
   * @returns {DataSeries<DataType>}
   *
   * The following code sample shows how to use seriesByPrioritizedTypes to display the first numeric series in a data source as a single value.
   *
   * If no numeric series are found in the data, the first series of type string is displayed. If no string series are found, the first series of type time is displayed.
   *
   * ```
   * <SingleValue
   *     options={{
   *         sparklineValues: '> primary | seriesByPrioritizedTypes'("number", "string", "time"),
   *     }}
   *     dataSources={{
   *         primary: {
   *             data: {
   *                 columns: [
   *                     [
   *                         '2018-08-19T00:00:00.000+00:00',
   *                         '2018-08-20T00:00:00.000+00:00',
   *                         '2018-08-21T00:00:00.000+00:00',
   *                         '2018-08-22T00:00:00.000+00:00',
   *                         '2018-08-23T00:00:00.000+00:00',
   *                         '2018-08-24T00:00:00.000+00:00',
   *                         '2018-08-25T00:00:00.000+00:00',
   *                         '2018-08-26T00:00:00.000+00:00',
   *                     ],
   *                     [ 'INFO', 'ERROR', 'WARN', 'INFO', 'ERROR', 'WARN', 'INFO', 'WARN'],
   *                 ],
   *                 fields: [
   *                     {
   *                         name: '_time',
   *                     },
   *                     {
   *                         name: 'status',
   *                     },
   *                 ],
   *             },
   *             meta: {},
   *         },
   *     }}
   * />
   */
  seriesByPrioritizedTypes(...types) {
    var _a;
    for (const type of types) {
      const matchedSeries = this.seriesByType(type);
      if (Array.isArray(matchedSeries == null ? void 0 : matchedSeries.points) && ((_a = matchedSeries == null ? void 0 : matchedSeries.points) == null ? void 0 : _a.length)) {
        return matchedSeries;
      }
    }
    return this.series[0];
  }
  /**
   * Set all values in the DataFrame to a static TypedValue.
   * @public
   * @param {TypedValue} v
   */
  setValue(v) {
    this.series.forEach((s) => s.setValue(v));
  }
  /**
   * Get all values in the DataFrame. This excludes field names.
   * @public
   * @returns {array}
   */
  getRawValue() {
    const values = [];
    this.series.forEach((s) => {
      values.push(s.getRawValue());
    });
    return values;
  }
  /**
   * Get all values and their types in the DataFrame. This excludes field names.
   * @public
   * @returns {TypedValue[][]}
   */
  getValue() {
    const values = [];
    this.series.forEach((s) => {
      values.push(s.getValue());
    });
    return values;
  }
  /**
   * Get the names of each DataSeries in the DataFrame.
   * @public
   * @returns {DataSeries<string>}
   *
   * ```
   * <Table
   *   options={{
   *       headers: '> table | getField()'
   *   }},
   *   dataSources={{
   *     primary: {
   *       data: {
   *         fields: [
   *           {
   *              name: 'Name'
   *           },
   *           {
   *              name: 'UserID'
   *           },
   *           {
   *              name: 'Money Spent'
   *           },
   *           {
   *              name: 'Most Recent Game'
   *           },
   *         ],
   *         columns: [
   *           [
   *              'Ms. Herman Beer',
   *              'Crystal Ziemann',
   *              'Phil Bartoletti',
   *              'Janis Kiehn V',
   *              'Angel Krajcik',
   *              'Patti Hodkiewicz IV',
   *              'Joanne Emmerich',
   *              'Jay Renner',
   *              'Ora Borer',
   *              'Dr. Bradford Gulgowski'
   *           ],
   *           [
   *              'Enrico98',
   *              'Taylor_Parker83',
   *              'Candice_Carroll',
   *              'Yolanda_McLaughlin95',
   *              'Modesto84',
   *              'Elwin52',
   *              'Francis8',
   *              'Charley.Feeney85',
   *              'Jensen_Jacobson74',
   *              'Dore_Volkman'
   *           ],
   *           [
   *              9740890.83,
   *              2107983.52,
   *              5467223.67,
   *              9529184.93,
   *              9692275.78,
   *              9395814.7,
   *              5692737.43,
   *              1001734.82,
   *              3848531.8,
   *              1691776.38
   *           ],
   *           [
   *              '2020-04-12T06:32:08-07:00',
   *              '2020-06-06T16:14:04-07:00',
   *              '2020-02-12T09:43:25-08:00',
   *              '2020-07-25T13:19:49-07:00',
   *              '2020-03-16T21:46:40-07:00',
   *              '2020-08-21T08:38:55-07:00',
   *              '2020-09-26T16:06:03-07:00',
   *              '2020-08-10T14:54:16-07:00',
   *              '2020-08-11T16:49:24-07:00',
   *              '2020-09-29T03:52:51-07:00'
   *           ]
   *         ]
   *      },
   *      meta: {
   *        totalCount: 100
   *      },
   *      requestParams: {
   *        count: 10,
   *        offset: 0
   *      }
   *     }
   *   }}
   * />
   *
   * Display the third and fourth DataSeries in a column chart as overlay fields.
   *
   * <Column
   *   options={{
   *     overlayFields: '> primary | frameBySeriesIndex(2,3) | getField()'
   *   }},
   *   dataSources={{
   *     primary: {
   *       requestParams: { offset: 0, count: 20},
   *       data: {
   *         fields: [
   *             { name: '_time' },
   *             { name: 'splunkd' },
   *             { name: 'splunkd_web_access' },
   *             { name: 'mongod' },
   *         ],
   *         columns: [
   *             [
   *                 '2018-05-02T18:15:46.000-07:00',
   *                 '2018-05-02T18:15:47.000-07:00',
   *                 '2018-05-02T18:15:48.000-07:00',
   *                 '2018-05-02T18:15:49.000-07:00',
   *                 '2018-05-02T18:15:50.000-07:00',
   *             ],
   *             ['67228', '83195', '3145', '19332', '29763'],
   *             ['67228', '83195', '3145', '19332', '29763'],
   *             ['14881', '17341', '18081', '19774', '10467'],
   *         ]
   *       },
   *       meta: {
   *         totalCount: 100,
   *       }
   *     }
   *   }}
   * />
   */
  getField() {
    const points = this.series.map((s) => s.getField());
    return new DataSeries(points);
  }
  /**
   * Get the data type of each DataSeries in the DataFrame.
   * @public
   * @returns {string[]}
   */
  getType() {
    return this.series.map((s) => s.getType());
  }
  /**
   * Get the global minimum value from all numeric DataSeries in the DataFrame.
   * @public
   * @returns {number}
   *
   * The following code sample shows how to use min to display the smallest data point in a data source as a single value.
   *
   * ```
   * <SingleValue
   *     options={{
   *         majorValue: '> primary | min()',
   *         trendDisplay: 'off',
   *         sparklineDisplay: 'off'
   *     }}
   *     dataSources={{
   *         primary: {
   *             data: {
   *                 fields: [
   *                     {
   *                         name: '_time',
   *                     },
   *                     {
   *                         name: 'count',
   *                     },
   *                 ],
   *                 columns: [
   *                     [
   *                         '2018-08-19T00:00:00.000+00:00',
   *                         '2018-08-20T00:00:00.000+00:00',
   *                         '2018-08-21T00:00:00.000+00:00',
   *                         '2018-08-22T00:00:00.000+00:00',
   *                         '2018-08-23T00:00:00.000+00:00',
   *                         '2018-08-24T00:00:00.000+00:00',
   *                         '2018-08-25T00:00:00.000+00:00',
   *                         '2018-08-26T00:00:00.000+00:00',
   *                     ],
   *                     ['1', '62', '103', '308', '587', '876', '930', '1320'],
   *                 ],
   *             },
   *             meta: {},
   *         },
   *     }}
   * />
   */
  min() {
    return this.minOrMax("min");
  }
  /**
   * Get the global maximum value from all numeric DataSeries in the DataFrame.
   * @public
   * @returns {number}
   *
   * The following code sample shows how to use max to display the largest data point in a data source as a single value.
   *
   * ```
   * <SingleValue
   *     options={{
   *         majorValue: '> primary | max()',
   *         trendDisplay: 'off',
   *         sparklineDisplay: 'off',
   *     }}
   *     dataSources={{
   *         primary: {
   *             data: {
   *                 fields: [
   *                     {
   *                         name: '_time',
   *                     },
   *                     {
   *                         name: 'count',
   *                     },
   *                 ],
   *                 columns: [
   *                     [
   *                         '2018-08-19T00:00:00.000+00:00',
   *                         '2018-08-20T00:00:00.000+00:00',
   *                         '2018-08-21T00:00:00.000+00:00',
   *                         '2018-08-22T00:00:00.000+00:00',
   *                         '2018-08-23T00:00:00.000+00:00',
   *                         '2018-08-24T00:00:00.000+00:00',
   *                         '2018-08-25T00:00:00.000+00:00',
   *                         '2018-08-26T00:00:00.000+00:00',
   *                     ],
   *                     [ '1', '62', '103', '308', '587', '876', '930', '1320' ],
   *                 ],
   *             },
   *             meta: {},
   *         },
   *     }}
   * />
   */
  max() {
    return this.minOrMax("max");
  }
  /**
   * runs result of min or max function over all the series and returns the data point
   * points
   * @param {string} aggName
   * @returns {DataPoint<T>}
   */
  minOrMax(funcName) {
    const overallSeries = new DataSeries();
    this.series.forEach((s) => {
      const m = s[funcName]();
      if (m) {
        overallSeries.points.push(m);
      }
    });
    return overallSeries[funcName]();
  }
};

// src/EncodingExecutor.ts
init_define_global();

// src/AST.ts
init_define_global();
var LITERAL_TYPES = ["number", "string"];

// src/FormatterPresets.ts
init_define_global();

// src/formatters/SetColorChannel.ts
init_define_global();

// esm-externals:chroma-js
var chroma_js_exports = {};
__export(chroma_js_exports, {
  default: () => chroma_js_default
});
init_define_global();
var defaultImport4 = __toESM(require("chroma-js"));
__reExport(chroma_js_exports, require("chroma-js"));
var chroma_js_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// src/Formatter.ts
init_define_global();

// src/DataSeriesLite.ts
init_define_global();
var DataSeriesLite = class extends DataSeries {
  /**
   *
   * @param {string} type user explicitly sets the data type
   * @param {string} field or column name
   * @param {ColumnVal} the raw values
   */
  constructor(values, type, field) {
    super([], type, field);
    this.internalPoints = [];
    this.values = values;
    const dataTypeForMeta = getDataTypeForMeta({ name: field, type });
    if (dataTypeForMeta !== "unknown") {
      this.type = dataTypeForMeta;
    }
  }
  get points() {
    this.values.forEach((rawValue, index) => {
      if (!this.internalPoints[index]) {
        this.createDataPointFromValueAtIndex(index);
      }
    });
    return this.internalPoints;
  }
  /**
   * Return first dataPoint in series.
   * @public
   * @returns {DataPoint}
   */
  firstPoint() {
    if (!this.internalPoints[0]) {
      this.createDataPointFromValueAtIndex(0);
    }
    return this.internalPoints[0];
  }
  /**
   * Return last dataPoint in series.
   * @public
   * @returns {DataPoint}
   */
  lastPoint() {
    if (!this.internalPoints[this.values.length - 1]) {
      this.createDataPointFromValueAtIndex(this.values.length - 1);
    }
    return this.internalPoints[this.internalPoints.length - 1];
  }
  /**
   * Finds dataPoint(s) in DataSeries by index(es).
   * @public
   * @param {...number} indexes
   * @returns {DataSeries}
   */
  pointsByIndexes(...indexes) {
    const indexedPoints = [];
    indexes.forEach((index) => {
      let dp = this.internalPoints[index];
      if (!dp) {
        dp = this.createDataPointFromValueAtIndex(index);
      }
      if (dp != null) {
        indexedPoints.push(dp);
      }
    });
    return new DataSeries(indexedPoints);
  }
  /**
   * Finds and returns the individual dataPoint at the given index.
   * @public
   * @param {number} index
   * @returns {DataPoint}
   */
  pointByIndex(indexIn) {
    let index = indexIn;
    if (index < 0) {
      index = this.values.length + index;
    }
    if (index < 0 || index >= this.values.length) {
      return null;
    }
    let dp = this.internalPoints[index];
    if (!dp) {
      dp = this.createDataPointFromValueAtIndex(index);
    }
    return dp;
  }
  /**
   * Finds the delta between the last point and point at the given index.
   * A negative index can be used, indicating an offset from the end of the sequence.
   * @public
   * @param {number} index
   * @returns {DataPoint}
   */
  delta(index) {
    const dp1 = this.lastPoint();
    if (dp1 === void 0) {
      return void 0;
    }
    const { field } = dp1;
    const { type, value: val1 } = dp1.getValue();
    if (type !== "number") {
      console.warn(`DSL delta cannot be computed for non-numerical data series of type ${type}`);
    }
    let dp2 = null;
    let delta;
    if (index >= 0) {
      dp2 = this.internalPoints[index];
      if (!dp2) {
        dp2 = this.createDataPointFromValueAtIndex(index);
      }
    } else {
      const newIndex = this.values.length + index;
      dp2 = this.internalPoints[newIndex];
      if (!dp2) {
        dp2 = this.createDataPointFromValueAtIndex(newIndex);
      }
    }
    if (dp2 == null) {
      console.warn("DSL delta cannot be computed, no data - invalid index");
    } else {
      const { value: val2 } = dp2.getValue();
      delta = val1 - val2;
    }
    if (Number.isNaN(delta)) {
      delta = void 0;
    }
    return new DataPoint(field, { type, value: delta });
  }
  /**
   * Sets all the values in the Data Series to a static TypedValue.
   * @param {TypedValue} v
   */
  setValue(v) {
    this.internalPoints.forEach((p) => {
      p.setValue(v);
    });
    this.values.fill(v.value);
    this.type = inferDataTypeFromDataPoints(this.points);
  }
  /**
   * Gets all the values + their type in the Data Series.
   * @returns {TypedValue[]}
   */
  getValue() {
    const values = [];
    this.points.forEach((p) => {
      values.push(p.getValue());
    });
    return values;
  }
  /**
   * Gets all the values (only) in the Data Series.
   * @returns {array}
   */
  getRawValue() {
    return this.values;
  }
  createDataPointFromValueAtIndex(index) {
    const dataType = getDataTypeForPoint(this.values[index], {
      name: this.field,
      type: this.type
    });
    this.internalPoints[index] = new DataPoint(String(this.field), {
      type: dataType,
      value: this.values[index]
    });
    return this.internalPoints[index];
  }
};

// src/Formatter.ts
var AbstractFormatter = class {
  format(dataPrimitive) {
    if (dataPrimitive instanceof DataFrame) {
      const newSeries = [];
      dataPrimitive.series.forEach((dataSeries, i) => {
        newSeries.push(this.formatSeries(dataSeries, i));
      });
      return new DataFrame(newSeries);
    }
    if (dataPrimitive instanceof DataSeries || dataPrimitive instanceof DataSeriesLite) {
      return this.formatSeries(dataPrimitive);
    }
    return this.formatPoint(dataPrimitive);
  }
  formatSeries(s, i = 0) {
    const newPoints = [];
    s.points.forEach((dataPoint, j) => {
      newPoints.push(this.formatPoint(dataPoint, s, i, j));
    });
    return new DataSeries(newPoints);
  }
  formatPoint(p, s, i = 0, j = 0) {
    const { field } = p;
    const dp = new DataPoint(field, { type: p.getValue().type, value: p.getValue().coercedValue });
    const tmp = this.formatTypedValue(dp, s, i, j);
    return new DataPoint(field, tmp);
  }
  makeArrays2D(a) {
    if (Array.isArray(a)) {
      if (Array.isArray(a[0])) {
        return a;
      }
      return [a];
    }
    throw new Error("argument wasn't array");
  }
};

// src/formatters/SetColorChannel.ts
var SetColorChannel = class extends AbstractFormatter {
  constructor(config) {
    super();
    this.config = EncodingExecutor.rawTree(config);
  }
  formatTypedValue(p) {
    const { value, type } = p.getValue();
    if (type !== "color") {
      return { type, value };
    }
    const channel = (0, lodash_exports.get)(this, "config.channel");
    const v = (0, lodash_exports.get)(this, "config.value");
    if (!channel || value == null) {
      console.warn(
        "SetColorChannel requires channel (ex: hsv.v, rgb.r) and value configuration to be set. It will return the same color when missing."
      );
    }
    try {
      return {
        type: "color",
        value: chroma_js_default(value.toString()).set(channel, v).hex()
      };
    } catch (error) {
      console.warn(error);
      return { type: "color", value };
    }
  }
};

// src/formatters/Prefix.ts
init_define_global();
var Prefix = class extends AbstractFormatter {
  constructor(prefix) {
    super();
    this.prefix = EncodingExecutor.rawTree(prefix);
  }
  formatTypedValue(p) {
    const { value } = p.getValue();
    const prefixedValue = this.prefix + value.toString();
    return { value: prefixedValue, type: "string" };
  }
};

// src/formatters/MatchValue.ts
init_define_global();
var MatchValue = class extends AbstractFormatter {
  constructor(matches, defaultValue = void 0) {
    super();
    this.matches = EncodingExecutor.rawTree(matches);
    this.defaultValue = defaultValue === void 0 ? void 0 : setDefaultValue(defaultValue);
  }
  formatTypedValue(input) {
    const { value } = input.getValue();
    const defaultMatchValue = (0, lodash_exports.isUndefined)(this.defaultValue) ? value || "" : this.defaultValue;
    const matchWildcard = (pattern, val) => {
      if (pattern === "*") return true;
      const parts = pattern.split(/\*+/);
      const firstPart = parts[0];
      const lastPart = parts[parts.length - 1];
      if (firstPart && !val.startsWith(firstPart)) return false;
      if (parts.length > 1 && lastPart && !val.endsWith(lastPart)) return false;
      let currentIndex = firstPart.length;
      for (let i = 1; i < parts.length - 1; i += 1) {
        const part = parts[i];
        currentIndex = val.indexOf(part, currentIndex);
        if (currentIndex === -1) return false;
        currentIndex += part.length;
      }
      return true;
    };
    const matchNumber = (m) => isNumber(value) && isNumber(m.match) && parseFloat(m.match) === parseFloat(value);
    const matchFunc = (m) => {
      if (m.match === 0 && (value === 0 || Number(value) === 0)) return true;
      if (m.match === null && value === null) return true;
      if (!m || !m.match) return false;
      if (typeof m.match === "string") {
        if (value === null && m.match !== "*") return false;
        if (m.match.includes("*")) {
          return matchWildcard(m.match, value == null ? void 0 : value.toString());
        }
        return m.match === value;
      }
      return matchNumber(m);
    };
    const calculateSpecificity = (pattern) => {
      const collapsedPattern = pattern.replace(/\*+/g, "*");
      const wildcardCount = (collapsedPattern.match(/\*/g) || []).length;
      if (collapsedPattern === "*") {
        return -100;
      }
      return collapsedPattern.length - wildcardCount * 2;
    };
    let bestMatch = null;
    let bestSpecificity = -Infinity;
    let foundExactMatch = false;
    this.matches.forEach((m) => {
      if (foundExactMatch || !matchFunc(m)) return;
      if (m.match === value) {
        bestMatch = m;
        foundExactMatch = true;
        return;
      }
      const specificity = calculateSpecificity(m.match);
      if (specificity > bestSpecificity) {
        bestMatch = m;
        bestSpecificity = specificity;
      }
    });
    const updatedValue = bestMatch !== null ? bestMatch.value : defaultMatchValue;
    const updatedType = getDataTypeForPoint(updatedValue);
    return { value: updatedValue, type: updatedType };
  }
};

// src/formatters/RangeValue.ts
init_define_global();
var { hasOwnProperty } = Object.prototype;
var RangeValue = class extends AbstractFormatter {
  constructor(ranges, defaultValue) {
    super();
    this.ranges = EncodingExecutor.rawTree(ranges);
    this.defaultValue = setDefaultValue(defaultValue);
  }
  formatTypedValue(p) {
    const { type, value } = p.getValue();
    if (type !== "number") {
      console.warn(`type '${type}' with value '${value}' is not a valid input to rangeValue`);
    }
    let rangeValueResult;
    const defaultRangeValue = (0, lodash_exports.isUndefined)(this.defaultValue) && !isNumber(value) ? value : this.defaultValue;
    if (isNumber(value)) {
      const floatValue = parseFloat(value);
      for (let i = 0; i < this.ranges.length; i += 1) {
        if (
          // open upper bound: value is bigger than or equal to open upper bound start (from)
          // if there are several 'from'-only ranges, we look at the first one that satisfies the mapping criteria
          // if there is overlap between a 'from'-only range and an inbetween range, this means that the ranges config is semantically invalid
          // TODO: figure out if we want to enforce a semantically valid config by sorting,
          // or by throwing an error if there are multiple 'from'/'to'-only ranges
          hasOwnProperty.call(this.ranges[i], "from") && !hasOwnProperty.call(this.ranges[i], "to") && floatValue >= this.ranges[i].from || // inbetween: value falls into from (inclusive) - to (exclusive) range
          floatValue >= this.ranges[i].from && floatValue < this.ranges[i].to || hasOwnProperty.call(this.ranges[i], "to") && !hasOwnProperty.call(this.ranges[i], "from") && floatValue < this.ranges[i].to
        ) {
          rangeValueResult = this.ranges[i].value;
          break;
        }
      }
    }
    const updatedValue = (0, lodash_exports.isUndefined)(rangeValueResult) ? defaultRangeValue : rangeValueResult;
    const updatedType = getDataTypeForPoint(updatedValue);
    return { type: updatedType, value: updatedValue };
  }
};

// src/formatters/Gradient.ts
init_define_global();
var DEFAULT_MIN_COLOR = "rgba(123,86,219,0.4)";
var DEFAULT_MAX_COLOR = "rgba(123,86,219,1)";
var Gradient = class extends AbstractFormatter {
  constructor(config) {
    super();
    this.sortArray = (array) => {
      array.sort((a, b) => a - b);
    };
    this.addDefaultEndingColors = (colors, n) => {
      for (let i = 0; i < n; i += 1) {
        colors.push(DEFAULT_MAX_COLOR);
      }
    };
    this.ignoreMinMaxWhenNeeded = (min, max, stops, newStops, newColors) => {
      if (min >= stops[0]) {
        newStops.shift();
        newColors.shift();
      }
      if (max <= stops[stops.length - 1]) {
        newStops.pop();
        newColors.pop();
      }
    };
    this.config = EncodingExecutor.rawTree(config) || {};
    this.colors = this.config.colors || [];
    this.stops = this.config.stops || [];
    if (!Array.isArray(this.colors) || !Array.isArray(this.stops)) {
      throw new Error("Gradient config: both 'colors' and 'stops' in should be 1D array.");
    }
    this.colors.forEach((c) => {
      if (!isColor(c)) {
        throw new Error("Gradient config: every element in 'colors' should be a color.");
      }
    });
    this.sortArray(this.stops);
  }
  prepareColorsAndStopsSeries(series) {
    const colorsLength = this.colors.length;
    const stopsLength = this.stops.length;
    const min = Number(series.min().getRawValue());
    const max = Number(series.max().getRawValue());
    let newColors = [DEFAULT_MIN_COLOR, DEFAULT_MAX_COLOR];
    if (stopsLength === 0) {
      if (colorsLength > 2) {
        const newStops2 = [];
        for (let i = 0; i < colorsLength; i += 1) {
          newStops2.push(min + (max - min) * i / (colorsLength - 1));
        }
        return { newStops: newStops2, newColors: this.colors };
      }
      this.colors.forEach((c, i) => {
        newColors[i] = c;
      });
      return {
        newStops: [min, max],
        newColors
      };
    }
    const newStops = [...this.stops];
    newStops.unshift(min);
    newStops.push(max);
    if (colorsLength === 0) {
      if (stopsLength === 1) {
        newColors = [DEFAULT_MIN_COLOR, DEFAULT_MAX_COLOR, DEFAULT_MAX_COLOR];
      } else if (stopsLength === 2) {
        newColors = [DEFAULT_MIN_COLOR, DEFAULT_MIN_COLOR, DEFAULT_MAX_COLOR, DEFAULT_MAX_COLOR];
      } else {
        throw new Error("Gradient config: provide at most two stops when colors is empty.");
      }
      this.ignoreMinMaxWhenNeeded(min, max, this.stops, newStops, newColors);
      return {
        newStops,
        newColors
      };
    }
    if (stopsLength + 2 >= colorsLength) {
      newColors = [...this.colors];
      if (stopsLength >= colorsLength) {
        newColors.unshift(DEFAULT_MIN_COLOR);
      }
      this.addDefaultEndingColors(newColors, stopsLength + 2 - newColors.length);
      this.ignoreMinMaxWhenNeeded(min, max, this.stops, newStops, newColors);
      if (newStops.length !== newColors.length) {
        throw new Error("Gradient config: not equal length of stops and colors.");
      }
      return {
        newStops,
        newColors
      };
    }
    throw new Error("Gradient config: too many colors set for the given stops.");
  }
  prepareColorsAndStopsPoint(value) {
    let newStops = this.stops;
    let newColors = this.colors;
    if (this.stops.length === 0) {
      newStops = [0, 1];
    }
    if (this.colors.length === 0) {
      newColors = [DEFAULT_MIN_COLOR, DEFAULT_MAX_COLOR];
    }
    if (this.stops.length === this.colors.length && this.stops.length === 1 && value < this.stops[0]) {
      newColors = [DEFAULT_MIN_COLOR, ...this.colors];
    }
    return { newStops, newColors };
  }
  formatTypedValue(p, series) {
    const input = p.getValue();
    const { type, value } = input;
    if (type !== "number") {
      throw new Error(`Type '${type}' with value '${value}' is not a valid input to gradient`);
    }
    const isDataSeries = series && series.points && series.points.length;
    const { newStops, newColors } = isDataSeries ? this.prepareColorsAndStopsSeries(series) : this.prepareColorsAndStopsPoint(value);
    let interpolateColor;
    const isBeyondUpperBound = value > newStops[newStops.length - 1];
    const isBeyondLowerBound = value < newStops[0];
    if (isBeyondUpperBound || isBeyondLowerBound) {
      const index = isBeyondUpperBound ? newColors.length - 1 : 0;
      interpolateColor = chroma_js_default(newColors[index]).hex().toUpperCase();
      return { type: "color", value: interpolateColor };
    }
    for (let i = 1; i < newStops.length; i += 1) {
      if (Number.isNaN(Number(newStops[i]))) {
        console.warn(
          "Could not format gradient color: stops are required to be numbers. Falling back to first color."
        );
        interpolateColor = chroma_js_default(newColors[0]).hex().toUpperCase() || "#000";
        return { type: "color", value: interpolateColor };
      }
      const upperVal = newStops[i];
      if (value <= upperVal) {
        const lowerVal = newStops[i - 1];
        let tau = 0;
        if (upperVal === lowerVal) {
          tau = value === 0 ? 0 : 1;
        } else {
          tau = (value - lowerVal) / (upperVal - lowerVal);
        }
        interpolateColor = chroma_js_default.scale([newColors[i - 1], newColors[i]])(tau).hex().toUpperCase();
        return { type: "color", value: interpolateColor };
      }
    }
    console.warn(`Could not format value for gradient: ${value}`);
    interpolateColor = chroma_js_default(newColors[0]).hex().toUpperCase() || "#000";
    return { type: "color", value: interpolateColor };
  }
};

// src/formatters/Pick.ts
init_define_global();
var Pick = class extends AbstractFormatter {
  constructor(formatConfig) {
    super();
    this.config = EncodingExecutor.rawTree(formatConfig);
  }
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  formatTypedValue(p, s, i = 0, j = 0) {
    let val;
    if (Array.isArray(this.config)) {
      val = this.config[j % this.config.length];
    } else {
      val = this.config[s.field];
    }
    return TypeSafeValue.fromRaw(val);
  }
};

// src/formatters/Type.ts
init_define_global();
var Type = class extends AbstractFormatter {
  formatTypedValue(p) {
    if (p && p.getRawValue() === null) {
      return TypeSafeValue.from({ type: "string", value: "null" });
    }
    return TypeSafeValue.fromRaw(p.getType());
  }
};

// src/formatters/FormatByType.ts
init_define_global();

// esm-externals:numbro
var numbro_exports = {};
__export(numbro_exports, {
  default: () => numbro_default
});
init_define_global();
var defaultImport5 = __toESM(require("numbro"));
__reExport(numbro_exports, require("numbro"));
var numbro_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// src/formatters/FormatByType.ts
var formatNumber = (number, config) => {
  const mappedConfig = {
    prefix: !(0, lodash_exports.isEmpty)(config.unit) && config.unitPosition === "before" ? `${config.unit} ` : void 0,
    postfix: !(0, lodash_exports.isEmpty)(config.unit) && config.unitPosition !== "before" ? ` ${config.unit}` : void 0,
    mantissa: typeof config.precision === "number" ? config.precision : void 0
  };
  const c = (0, lodash_exports.defaultsDeep)(
    {},
    (0, lodash_exports.omitBy)(mappedConfig, lodash_exports.isUndefined),
    (0, lodash_exports.omit)(config, ["unit", "unitPosition", "precision"])
  );
  return numbro_default(number).format(c);
};
var formatString = (string, config) => {
  if (!(0, lodash_exports.isEmpty)(config.unit)) {
    return config.unitPosition === "before" ? `${config.unit} ${string}` : `${string} ${config.unit}`;
  }
  return `${string}`;
};
var formatTime = (dateString, defaultValue, config) => {
  if (typeof config.format === "string" && !(0, lodash_exports.isEmpty)(config.format)) {
    return formatTimeWithTimezoneCorrection(dateString, config.format);
  }
  return defaultValue.toString();
};
var FormatByType = class extends AbstractFormatter {
  constructor(config) {
    super();
    this.config = { number: {}, string: {}, time: { format: "" } };
    this.config = (0, lodash_exports.defaultsDeep)({}, config, this.config);
  }
  formatTypedValue(p) {
    const { number: numberConfig, string: stringConfig, time: timeConfig } = this.config;
    const value = p.getValue();
    switch (value.type) {
      case "number":
        return new TypeSafeValue(
          "string",
          formatNumber(p.getRawValue(), numberConfig),
          value.value
        );
      case "string":
        return new TypeSafeValue("string", formatString(value.value, stringConfig), value.value);
      case "time":
        return new TypeSafeValue(
          "string",
          formatTime(value.coercedValue, value.value, timeConfig),
          value.value
        );
      default:
        return p.getValue();
    }
  }
};

// src/formatters/Frame.ts
init_define_global();

// src/DataPrimitive.ts
init_define_global();
function isDataPrimitive(o) {
  return DataFrame.isDataFrame(o) || DataSeries.isDataSeries(o) || DataPoint.isDataPoint(o);
}

// src/formatters/Helper.ts
init_define_global();
var Helper = class _Helper {
  static isRawDataFrame(d) {
    return Array.isArray(d) && _Helper.isRawDataSeries(d[0]);
  }
  static isRawDataSeries(d) {
    return Array.isArray(d) && !EncodingExecutor.isObject(d[0]);
  }
  static isRawDataPoint(d) {
    return !EncodingExecutor.isObject(d);
  }
  static dataPrimitiveFromRaw(d) {
    if (_Helper.isRawDataFrame(d)) {
      return DataFrame.fromRaw(d);
    }
    if (_Helper.isRawDataSeries(d)) {
      return DataSeries.fromRaw(d);
    }
    if (_Helper.isRawDataPoint(d)) {
      return DataPoint.fromRaw(d);
    }
    throw new Error(`raw value does not resemble DataFrame, DataSeries, or DataPoint`);
  }
};

// src/formatters/Frame.ts
var Frame = class {
  constructor(...args) {
    this.args = [];
    this.args = args.map(
      (a) => isDataPrimitive(a) ? a : Helper.dataPrimitiveFromRaw(EncodingExecutor.rawTree(a))
    );
  }
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  format(ignored) {
    let series = [];
    this.args.forEach((dataPrim) => {
      if (DataSeries.isDataSeries(dataPrim)) {
        series.push(dataPrim);
      } else if (DataFrame.isDataFrame(dataPrim)) {
        series = series.concat(dataPrim.series);
      } else if (DataPoint.isDataPoint(dataPrim)) {
        series.push(new DataSeries([dataPrim]));
      } else {
        throw new Error(`frame formatter args incorrect`);
      }
    });
    return new DataFrame(series);
  }
};

// src/formatters/Prepend.ts
init_define_global();
var Prepend = class {
  constructor(d) {
    this.prependMe = isDataPrimitive(d) ? d : Helper.dataPrimitiveFromRaw(EncodingExecutor.rawTree(d));
  }
  format(subject) {
    if (DataFrame.isDataFrame(subject)) {
      return this.prependToFrame(subject);
    }
    if (DataSeries.isDataSeries(subject)) {
      return this.prependToSeries(subject);
    }
    throw new Error(`Can only prepend to DataFrame or DataSeries`);
  }
  prependToFrame(subject) {
    if (DataFrame.isDataFrame(this.prependMe)) {
      return this.prependFrameToFrame(subject);
    }
    if (DataSeries.isDataSeries(this.prependMe)) {
      return this.prependASeriesToEachSeriesOfFrame(subject);
    }
    if (DataPoint.isDataPoint(this.prependMe)) {
      return this.prependAPointToEachSeriesOfFrame(subject);
    }
    throw new Error(`'prepend' formatter only accepts DataFrame, DataSeries, or DataPoint as argument`);
  }
  prependToSeries(subject) {
    if (DataFrame.isDataFrame(this.prependMe)) {
      throw new Error("cannot prepend a DataFrame to a DataSeries");
    } else if (DataSeries.isDataSeries(this.prependMe)) {
      return this.prependSeriesToSeries(subject, this.prependMe);
    } else if (DataPoint.isDataPoint(this.prependMe)) {
      return this.prependPointToSeries(subject);
    }
    throw new Error(`'prepend' to series formatter only DataSeries, or DataPoint as argument`);
  }
  prependAPointToEachSeriesOfFrame(dp) {
    return new DataFrame(dp.series.map((s) => this.prependPointToSeries(s)));
  }
  prependASeriesToEachSeriesOfFrame(frame) {
    return new DataFrame(
      frame.series.map((s) => this.prependSeriesToSeries(s, this.prependMe))
    );
  }
  prependFrameToFrame(frame) {
    const numSeries1 = this.prependMe.series.length;
    const numSeries2 = frame.series.length;
    if (numSeries1 !== numSeries2) {
      throw new Error(
        `can't prepend a frame with ${numSeries1} columns to a field with ${numSeries2} columns`
      );
    }
    return new DataFrame(
      frame.series.map(
        (s, i) => this.prependSeriesToSeries(s, this.prependMe.seriesByIndex(i))
      )
    );
  }
  prependSeriesToSeries(series, prependMe) {
    const { field } = series;
    const type1 = series.points.length > 0 ? series.points[0].getValue().type : void 0;
    const type2 = prependMe.points.length > 0 ? prependMe.points[0].getValue().type : void 0;
    if (type1 && type2 && type1 !== type2) {
      throw new Error(`cannot prepend ${type2} to ${type1}`);
    }
    return new DataSeries(
      prependMe.points.map((p) => new DataPoint(field, p.getValue())).concat(series.points)
    );
  }
  prependPointToSeries(s) {
    const { field } = s;
    const typedValue = s.firstPoint().getValue();
    const type1 = typedValue.type;
    const typedValue2 = this.prependMe.getValue();
    const type2 = typedValue2.type;
    if (type1 !== type2) {
      throw new Error(`cannot prepend point of type ${type2} to series of type ${type1}`);
    }
    const newPoint = new DataPoint(field, typedValue2);
    return new DataSeries([newPoint, ...s.points]);
  }
};

// src/formatters/MultiFormat.ts
init_define_global();
var MultiFormat = class {
  constructor(formatConfig) {
    this.config = EncodingExecutor.rawTree(formatConfig);
  }
  format(f) {
    const namesDataSeries = f.seriesByName(this.config.nameField);
    const valuesDataSeries = f.seriesByName(this.config.valueField);
    return namesDataSeries.points.map((name, i) => {
      const { type, config } = this.config.formatters[name.getRawValue()];
      const FormatterClass = formatterClasses[type];
      const value = valuesDataSeries.pointByIndex(i);
      if (!FormatterClass) {
        throw new Error(`unknown formatter type "${type}" was specified`);
      }
      return new FormatterClass(config).format(value, valuesDataSeries);
    });
  }
};

// src/formatters/MaxContrast.ts
init_define_global();
var MaxContrast = class extends AbstractFormatter {
  constructor(config) {
    super();
    this.config = EncodingExecutor.rawTree(config);
  }
  formatTypedValue(p) {
    const { value, type } = p.getValue();
    if (type !== "color" || !isColor(value)) {
      return { type, value };
    }
    const colorConfig = (0, lodash_exports.get)(this, "config.colors");
    const defaultColor = (0, lodash_exports.get)(this, "config.default");
    if (!Array.isArray(colorConfig) || colorConfig.length === 0) {
      return isColor(defaultColor) ? { type: "color", value: defaultColor } : { type, value };
    }
    if (value === "transparent" && isColor(defaultColor)) {
      return { type: "color", value: defaultColor };
    }
    try {
      return {
        type: "color",
        value: (0, lodash_exports.chain)(colorConfig).map((c) => ({ color: c, contrast: chroma_js_default.contrast(value, c) })).maxBy("contrast").value().color
      };
    } catch (error) {
      console.warn(error);
      return { type: "color", value: defaultColor || value };
    }
  }
};

// src/formatters/RenameSeries.ts
init_define_global();

// src/formatters/Default.ts
init_define_global();
var Default = class extends AbstractFormatter {
  constructor(val) {
    super();
    this.defaultVal = EncodingExecutor.rawTree(val);
  }
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  formatTypedValue(p, s, i = 0, j = 0) {
    if (p.getRawValue() === void 0) {
      return TypeSafeValue.fromRaw(this.defaultVal);
    }
    return p.getValue();
  }
};

// src/formatters/RenameSeries.ts
var RenameSeries = class extends Default {
  constructor(name) {
    super(name);
    this.newFieldName = name;
  }
  formatPoint(p, s, i = 0, j = 0) {
    return i === 0 && typeof this.newFieldName === "string" && this.newFieldName.length > 0 ? new DataPoint(this.newFieldName, this.formatTypedValue(p, s, i, j)) : super.formatPoint(p, s, i, j);
  }
};

// src/formatters/DivideBy.ts
init_define_global();
var DivideBy = class extends AbstractFormatter {
  constructor(divisor) {
    super();
    this.divisor = EncodingExecutor.rawTree(divisor);
  }
  formatTypedValue(p) {
    const { value } = p.getValue();
    const dividedValue = this.divisor !== 0 && value / this.divisor;
    return { value: dividedValue, type: "number" };
  }
};

// src/formatters/Subtract.ts
init_define_global();
var Subtract = class extends AbstractFormatter {
  constructor(valToSubtract) {
    super();
    this.valToSubtract = EncodingExecutor.rawTree(valToSubtract);
  }
  formatTypedValue(p) {
    const { value } = p.getValue();
    const difference = this.valToSubtract !== 0 && value - this.valToSubtract;
    return { value: difference, type: "number" };
  }
};

// src/FormatterPresets.ts
var formatterClasses = {
  gradient: Gradient,
  matchValue: MatchValue,
  prefix: Prefix,
  rangeValue: RangeValue,
  pick: Pick,
  multiFormat: MultiFormat,
  type: Type,
  formatByType: FormatByType,
  frame: Frame,
  prepend: Prepend,
  objects: Objects,
  setColorChannel: SetColorChannel,
  maxContrast: MaxContrast,
  renameSeries: RenameSeries,
  divideBy: DivideBy,
  subtract: Subtract
};

// src/OptionScopes.ts
init_define_global();
var _OptionScopes = class _OptionScopes {
  constructor(optionsStanza, frames, themeFunc, bypassCloneDeepOptionScope) {
    // feature flag setting to bypass the call to cloneDeep inside the resolve function
    this.local = [];
    // unqualified identifiers can be resolved against local context. This is a stack of scopes.
    this.visitedPaths = /* @__PURE__ */ new Set();
    this.context = optionsStanza.context;
    this.executedOptions = optionsStanza.options;
    this.frames = frames;
    this.themeFunc = themeFunc;
    this.bypassCloneDeepOptionScope = bypassCloneDeepOptionScope;
    this.local.push(this.executedOptions);
  }
  resolve(identifier) {
    const scopeParts = identifier.split(".");
    let scopedValue = null;
    if (_OptionScopes.isQualified(scopeParts)) {
      scopedValue = this.resolveQualifiedIdentifier(scopeParts);
    } else {
      scopedValue = this.resolveUnqualifiedIdentifier(scopeParts);
    }
    if (this.bypassCloneDeepOptionScope) {
      return scopedValue;
    }
    return (0, lodash_exports.cloneDeep)(scopedValue);
  }
  static isQualified(scopeParts) {
    const firstPart = scopeParts[0];
    return _OptionScopes.SCOPES.includes(firstPart);
  }
  resolveUnqualifiedIdentifier(scopeParts) {
    const qualifiers = _OptionScopes.SCOPES;
    let scopedValue;
    for (let i = 0; i < qualifiers.length; i += 1) {
      const qualifiedIdentifier = [qualifiers[i], ...scopeParts];
      scopedValue = this.resolveQualifiedIdentifier(qualifiedIdentifier);
      if (scopedValue.val) {
        break;
      }
    }
    return scopedValue;
  }
  resolveQualifiedIdentifier(scopeParts) {
    const qualifiedTargets = {
      context: this.context,
      options: this.executedOptions,
      datasources: this.frames,
      local: this.local[this.local.length - 1]
    };
    let val = null;
    const location = scopeParts[0];
    if (location === "themes" && this.themeFunc) {
      const themeKey = scopeParts[1];
      val = this.themeFunc(themeKey);
    } else {
      val = (0, lodash_exports.get)(qualifiedTargets, scopeParts);
      if (val) {
        val = new EncodingExecutor().eval(val, this, scopeParts);
      }
    }
    return { location, val };
  }
  pushLocalScope(o) {
    this.local.push(o);
  }
  popLocalScope() {
    this.local.pop();
  }
  addToVisitedList(path) {
    const pathStr = path.join(".");
    if (this.visitedPaths.has(pathStr)) {
      throw new Error(
        `Circular reference ${pathStr}, path history: ${new Array(...this.visitedPaths).toString()}`
      );
    }
    this.visitedPaths.add(pathStr);
  }
  removeFromVisitedList(path) {
    this.visitedPaths.delete(path.join("."));
  }
};
// Set of object paths we have visited (used for circular reference detection)
_OptionScopes.SCOPES = ["local", "context", "datasources", "options", "themes"];
var OptionScopes = _OptionScopes;

// src/DslParser.ts
init_define_global();

// esm-externals:nearley
var nearley_exports = {};
__export(nearley_exports, {
  default: () => nearley_default
});
init_define_global();
var defaultImport6 = __toESM(require("nearley"));
__reExport(nearley_exports, require("nearley"));
var nearley_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// src/DslParser.ts
var grammar = require_vizparser();
var _DslParser = class _DslParser {
  static parse(dsl) {
    if (_DslParser.cache[dsl]) {
      return [..._DslParser.cache[dsl]];
    }
    const parser = new nearley_exports.Parser(grammar);
    parser.feed(dsl);
    if (parser.results.length > 1) {
      console.warn(`Ambiguous parse of '${dsl}'`);
    }
    if (parser.results.length === 0) {
      console.warn(`No parsed results for '${dsl}'`);
    }
    _DslParser.cache[dsl] = [...parser.results[0]];
    return parser.results[0];
  }
};
_DslParser.cache = {};
var DslParser = _DslParser;

// src/EncodingParser.ts
init_define_global();
var EncodingParser = class _EncodingParser {
  static parseOptions(optionsStanza) {
    const optionsAST = { simpleOptions: {}, expressions: {}, context: optionsStanza.context };
    const { options } = optionsStanza;
    Object.keys(options).forEach((k) => {
      const v = options[k];
      if (_EncodingParser.isDslString(v)) {
        optionsAST.expressions[k] = DslParser.parse(_EncodingParser.withoutArrow(v));
      } else {
        optionsAST.simpleOptions[k] = v;
      }
    });
    return optionsAST;
  }
  static isDslString(s) {
    return s ? s.toString().trim().startsWith(">") : false;
  }
  static withoutArrow(s) {
    return s.toString().match(/\s*>\s*(.+$)/)[1].trim();
  }
  static parse(encoding) {
    const { dimensions: dslFields, context } = encoding;
    const ast = { dimensions: {}, context };
    Object.keys(dslFields).forEach((f) => {
      const astDimension = { value: [] };
      let value = null;
      if (typeof dslFields[f] === "string") {
        value = dslFields[f];
      } else {
        const dim = dslFields[f];
        value = dim.value;
      }
      astDimension.value = DslParser.parse(value);
      ast.dimensions[f] = astDimension;
    });
    return ast;
  }
};

// src/EncodingExecutor.ts
var EncodingExecutor = class _EncodingExecutor {
  executeOptions(optionsStanza, frames, themeFunc, bypassCloneDeepOptionScope) {
    const ret = (0, lodash_exports.cloneDeep)(optionsStanza);
    const scopes = new OptionScopes(ret, frames, themeFunc, bypassCloneDeepOptionScope);
    this.eval(ret, scopes);
    const returnValue = _EncodingExecutor.rawTree(ret.options);
    return returnValue;
  }
  /**
   * o is what we are evaluating. If it is an array or an object that its parts are recursively
   * evaluated. Any DSL expressions encountered are evaluated. The scopes object is uses by the
   * DSL expression to resolve any identifiers. The scope object's 'local' scope is updated by
   * pushLocalScope as the eval method moves through the tree. The path array for a path "context.a.b.c"
   * will be ['context', 'a', 'b','c']. As eval moves through the tree, the scopes add the current
   * path its visited list. If the current path is found in the visited list, then a circular reference
   * error is thrown.
   * current 'path' in the
   * @param o
   * @param {OptionScopes} scopes
   * @param {string[]} path
   * @returns {any}
   */
  eval(o, scopes, path = []) {
    scopes.pushLocalScope(o);
    scopes.addToVisitedList(path);
    if (Array.isArray(o)) {
      o.forEach((v, i) => {
        path.push(i.toString());
        o[i] = this.eval(o[i], scopes, path);
        path.pop();
      });
    } else if ((0, lodash_exports.isPlainObject)(o)) {
      Object.keys(o).forEach((k) => {
        path.push(k);
        o[k] = this.eval(o[k], scopes, path);
        path.pop();
      });
    } else if (EncodingParser.isDslString(o)) {
      scopes.popLocalScope();
      const tmp = this.evalDsl(o, scopes);
      scopes.removeFromVisitedList(path);
      return tmp;
    }
    scopes.popLocalScope();
    scopes.removeFromVisitedList(path);
    return o;
  }
  evalDsl(dsl, scopes) {
    try {
      const parsedDsl = DslParser.parse(EncodingParser.withoutArrow(dsl));
      const execOptionsPipelineValue = this.execOptionsPipeline(
        parsedDsl,
        scopes,
        scopes.frames.primary
      );
      return execOptionsPipelineValue;
    } catch (e) {
      return void 0;
    }
  }
  /**
   * Takes anything that can have DSL embedded in it, such as tree or array, and insures
   * that all DataPrimitive have been converted to their 'raw' equivalents
   * @param {object} o
   * @returns {any}
   */
  static rawTree(o) {
    if (Array.isArray(o)) {
      o.forEach((v, i) => {
        o[i] = _EncodingExecutor.rawTree(o[i]);
      });
      return o;
    }
    if ((0, lodash_exports.isPlainObject)(o)) {
      Object.keys(o).forEach((k) => {
        o[k] = _EncodingExecutor.rawTree(o[k]);
      });
      return o;
    }
    const tmp = isDataPrimitive(o) ? o.getRawValue() : o;
    return tmp;
  }
  /**
   * Executes sequence of pipe delimited expressions that constitute a DSL
   * @param {Expr[]} pipeline
   * @param {OptionScopes} scopes
   * @param {DataPrimitive<DataType>} origin
   * @param {ExecutedOptions} executedOptions
   * @returns {{location: string; val: Option | DataPrimitive}}
   */
  execOptionsPipeline(pipeline, scopes, origin) {
    let subject = origin;
    pipeline.forEach((expr, i) => {
      if (expr.type === "method") {
        if (subject) {
          subject = this.executeMethod(expr, subject, scopes.context);
        }
      } else if (expr.type === "identifier") {
        subject = scopes.resolve(expr.v.toString()).val;
      } else if (LITERAL_TYPES.includes(expr.type)) {
        const tsv = TypeSafeValue.from({ type: expr.type, value: expr.v });
        subject = new DataPoint("", tsv);
      }
      const isLastInPipeline = i === pipeline.length - 1;
      if (!isLastInPipeline && subject && !isDataPrimitive(subject)) {
        try {
          subject = Helper.dataPrimitiveFromRaw(subject);
        } catch (e) {
          const exprStr = expr.v ? expr.v : expr.name;
          throw new Error(
            `Output of '${exprStr}' cannot be piped because it is not a DataFrame, DataPoint, or DataSeries`
          );
        }
      }
    });
    return subject;
  }
  /**
   * Methods are either selector methods that built-ins such as
   * 'selectSeriesByPosition(...)",or they are formatter calls like 'rangeValue(...)'
   * @param {Method} expr
   * @param {DataPrimitive} subject
   * @param {Scopes} scopes
   * @param {string} metaName
   * @returns {DataPrimitive}
   */
  executeMethod(expr, subject, context) {
    const m = expr;
    const args = this.args(m.args, context);
    const method = subject[m.name];
    if (method) {
      subject = method.apply(subject, args);
    } else {
      subject = this.applyFormatter(subject, m.name, args);
    }
    return subject;
  }
  /**
   * Applies the Formatter to either metaData or value
   * @param {DataPrimitive} subject
   * @param {string} funcName
   * @param {ResolvedValue[]} args
   * @param {string} metaName
   */
  applyFormatter(subject, funcName, args) {
    const FormatterClass = formatterClasses[funcName];
    if (FormatterClass) {
      return new FormatterClass(...args).format(subject);
    }
    throw Error(`No such method or formatter function: '${funcName}'`);
  }
  /**
   * Sometimes when invoking a pipeline we may find degenerate pipelines like
   * '42' that simply set the metadata to a literal. Or, we may perhaps in
   * a value pipeline, we set the value to 'hello' after w perform selection
   * like "selectByPosition(0)|'hello'"
   * @param {DataPrimitive} subject
   * @param {LiteralSymbol} symbol
   */
  applyLiteral(subject, symbol) {
    const { type, v: value } = symbol;
    subject.setValue({ type, value });
  }
  /**
   * reduces method call arguments (ParserSymbols) to actual values
   * @param {ParserSymbol[]} args
   * @param {Scopes} scopes
   * @returns {any[]}
   */
  args(args, context) {
    return args.reduce((acc, cur) => {
      const v = this.getArg(cur, context);
      acc.push(v);
      return acc;
    }, []);
  }
  /**
   * Returns either the literal value from the symbol, or a value from context.
   * Throws error if identifier not found in context.
   * @param {ParserSymbol} s
   * @param {object} context
   * @returns {any}
   */
  getArg(s, context) {
    if (s.type === "identifier") {
      const val = context[s.v];
      if (!val) {
        throw Error(
          `Could not resolve ${s.v} in context. Did you mean one of '[${Object.keys(
            context
          ).toString()}]'`
        );
      }
      return val;
    }
    return s.v;
  }
  /**
   * Simple method to tell if the argument is an object or primitive.
   * @param opt
   * @returns {boolean}
   */
  static isObject(opt) {
    return Object(opt) === opt;
  }
};

// src/formatters/Objects.ts
var Objects = class {
  constructor(objectConfig) {
    this.config = EncodingExecutor.rawTree(objectConfig);
  }
  format(dp) {
    if (DataFrame.isDataFrame(dp)) {
      const mergedObjectSeries = this.seriesToObjects(dp.series[0]);
      for (let i = 1; i < dp.series.length; i += 1) {
        const mergeMeIn = this.seriesToObjects(dp.series[i]);
        for (let j = 0; j < mergedObjectSeries.length; j += 1) {
          mergedObjectSeries[j] = (0, lodash_exports.merge)(mergedObjectSeries[j], mergeMeIn[j]);
        }
      }
      return mergedObjectSeries;
    }
    if (DataSeries.isDataSeries(dp)) {
      return this.seriesToObjects(dp);
    }
    if (DataPoint.isDataPoint(dp)) {
      return [{ [dp.field]: dp.getRawValue() }];
    }
    throw new Error(`'objects' formatter only allowed on DataFrame, DataPoint, or DataSeries`);
  }
  seriesToObjects(s) {
    return s.points.reduce((acc, pt) => {
      let key = pt.field;
      if (this.config && this.config.rename) {
        key = this.config.rename[key] || key;
      }
      acc.push({ [key]: pt.getRawValue() });
      return acc;
    }, []);
  }
};
//# sourceMappingURL=Objects.js.map
