import { AbstractFormatter } from '../Formatter';
import { TypedValue } from '../DataPrimitive';
import { DataPoint } from '../DataPoint';
/**
 * Math function to subtract.
 *
 * ```js
 * <SampleViz
 *     context={{
 *         divisor: '> majorValue | subtract(trendValue)'
 *     }}
 * />
 * ```
 */
export declare class Subtract extends AbstractFormatter<'number', 'number'> {
    private valToSubtract;
    constructor(valToSubtract: any);
    protected formatTypedValue(p: DataPoint<'number'>): TypedValue<'number'>;
}
