/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/utils/findClosestMatchFromDefaultList.ts
var findClosestMatchFromDefaultList_exports = {};
__export(findClosestMatchFromDefaultList_exports, {
  findClosestMatchFromDefaultList: () => findClosestMatchFromDefaultList
});
module.exports = __toCommonJS(findClosestMatchFromDefaultList_exports);
var findClosestMatchFromDefaultList = (searchList, inputObj) => {
  if (!Array.isArray(searchList) || searchList.length === 0) {
    return -1;
  }
  const keys = Object.keys(inputObj);
  let maxMatchCnt = 0;
  let maxMatchIdx = 0;
  searchList.forEach((item, idx) => {
    let matchCnt = 0;
    keys.forEach((key) => {
      if (item[key] === inputObj[key]) {
        matchCnt += 1;
      }
    });
    if (Math.max(maxMatchCnt, matchCnt) > maxMatchCnt) {
      maxMatchCnt = matchCnt;
      maxMatchIdx = idx;
    }
  });
  return maxMatchIdx;
};
//# sourceMappingURL=findClosestMatchFromDefaultList.js.map
